/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         CISAparse
#define yylex           CISAlex
#define yyerror         CISAerror
#define yydebug         CISAdebug
#define yynerrs         CISAnerrs
#define yylval          CISAlval
#define yychar          CISAchar

/* First part of user prologue.  */
#line 9 "CISA.y"

#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>

#include "visa_igc_common_header.h"
#include "Common_ISA.h"
#include "Common_ISA_util.h"
#include "Common_ISA_framework.h"
#include "JitterDataStruct.h"
#include "VISAKernel.h"

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size);

void CISAerror(CISA_IR_Builder* builder, char const* msg);
int yylex(CISA_IR_Builder *pBuilder);
extern int CISAlineno;

static bool streq(const char *sym0, const char *sym1);
static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value);
static VISA_Align AlignBytesToVisaAlignment(int bytes);
static int DataTypeSizeOf(VISA_Type type);
static bool ParseEMask(const char* sym, VISA_EMask_Ctrl &emask);

//
// check if the cond is true.
// if cond is false, then print errorMessage (syntax error) and YYABORT
#define MUST_HOLD(cond, errorMessage) \
  {if (!(cond)) {pBuilder->RecordParseError(CISAlineno, errorMessage); YYABORT;}}
#define PARSE_ERROR_AT(LINE,...)\
  {pBuilder->RecordParseError(LINE, __VA_ARGS__); YYABORT;}
#define PARSE_ERROR(...)\
    PARSE_ERROR_AT(CISAlineno, __VA_ARGS__)

// Use this to wrap API calls that return false, nullptr, or 0 on failure
// It's assumed that the API call reported the parse error
#define ABORT_ON_FAIL(X) \
    do \
        if (!(X)) \
            YYABORT;\
    while (0)
#define TRACE(S) \
    do { \
      if (CISAout && pBuilder->debugParse()) \
          fprintf(CISAout, "line %d: %s", CISAlineno, S); \
    } while (0)

std::deque<const char*> switchLabels;
std::vector<VISA_opnd*> RTRWOperandsVec;

VISA_RawOpnd* rawOperandArray[16];

// global var for non-kernel attribute option.
// The var needs to be cleared before each use.
std::vector<attr_gen_struct*> AttrOptVar;


#line 142 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "CISA.tab.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ALIGN_KEYWORD = 3,              /* ALIGN_KEYWORD  */
  YYSYMBOL_ATOMIC_SUB_OP = 4,              /* ATOMIC_SUB_OP  */
  YYSYMBOL_DIRECTIVE_DECL = 5,             /* DIRECTIVE_DECL  */
  YYSYMBOL_DIRECTIVE_FUNC = 6,             /* DIRECTIVE_FUNC  */
  YYSYMBOL_DIRECTIVE_FUNCDECL = 7,         /* DIRECTIVE_FUNCDECL  */
  YYSYMBOL_DIRECTIVE_GLOBAL_FUNC = 8,      /* DIRECTIVE_GLOBAL_FUNC  */
  YYSYMBOL_DIRECTIVE_IMPLICIT = 9,         /* DIRECTIVE_IMPLICIT  */
  YYSYMBOL_DIRECTIVE_INPUT = 10,           /* DIRECTIVE_INPUT  */
  YYSYMBOL_DIRECTIVE_KERNEL = 11,          /* DIRECTIVE_KERNEL  */
  YYSYMBOL_DIRECTIVE_KERNEL_ATTR = 12,     /* DIRECTIVE_KERNEL_ATTR  */
  YYSYMBOL_DIRECTIVE_VERSION = 13,         /* DIRECTIVE_VERSION  */
  YYSYMBOL_ALIAS_EQ = 14,                  /* ALIAS_EQ  */
  YYSYMBOL_ALIGN_EQ = 15,                  /* ALIGN_EQ  */
  YYSYMBOL_ATTR_EQ = 16,                   /* ATTR_EQ  */
  YYSYMBOL_OFFSET_EQ = 17,                 /* OFFSET_EQ  */
  YYSYMBOL_NUM_ELTS_EQ = 18,               /* NUM_ELTS_EQ  */
  YYSYMBOL_V_NAME_EQ = 19,                 /* V_NAME_EQ  */
  YYSYMBOL_SIZE_EQ = 20,                   /* SIZE_EQ  */
  YYSYMBOL_V_TYPE_EQ_G = 21,               /* V_TYPE_EQ_G  */
  YYSYMBOL_V_TYPE_EQ_P = 22,               /* V_TYPE_EQ_P  */
  YYSYMBOL_V_TYPE_EQ_A = 23,               /* V_TYPE_EQ_A  */
  YYSYMBOL_V_TYPE_EQ_S = 24,               /* V_TYPE_EQ_S  */
  YYSYMBOL_V_TYPE_EQ_T = 25,               /* V_TYPE_EQ_T  */
  YYSYMBOL_CPS = 26,                       /* CPS  */
  YYSYMBOL_NON_UNIFORM_SAMPLER = 27,       /* NON_UNIFORM_SAMPLER  */
  YYSYMBOL_PIXEL_NULL_MASK = 28,           /* PIXEL_NULL_MASK  */
  YYSYMBOL_RAW_SEND_STRING = 29,           /* RAW_SEND_STRING  */
  YYSYMBOL_RAW_SENDC_STRING = 30,          /* RAW_SENDC_STRING  */
  YYSYMBOL_RAW_SENDS_STRING = 31,          /* RAW_SENDS_STRING  */
  YYSYMBOL_RAW_SENDS_EOT_STRING = 32,      /* RAW_SENDS_EOT_STRING  */
  YYSYMBOL_RAW_SENDSC_STRING = 33,         /* RAW_SENDSC_STRING  */
  YYSYMBOL_RAW_SENDSC_EOT_STRING = 34,     /* RAW_SENDSC_EOT_STRING  */
  YYSYMBOL_SAT = 35,                       /* SAT  */
  YYSYMBOL_SRCMOD_ABS = 36,                /* SRCMOD_ABS  */
  YYSYMBOL_SRCMOD_NEG = 37,                /* SRCMOD_NEG  */
  YYSYMBOL_SRCMOD_NEGABS = 38,             /* SRCMOD_NEGABS  */
  YYSYMBOL_SRCMOD_NOT = 39,                /* SRCMOD_NOT  */
  YYSYMBOL_BFN_OP = 40,                    /* BFN_OP  */
  YYSYMBOL_DPAS_OP = 41,                   /* DPAS_OP  */
  YYSYMBOL_SVM_ALIGNED = 42,               /* SVM_ALIGNED  */
  YYSYMBOL_SVM_UNALIGNED = 43,             /* SVM_UNALIGNED  */
  YYSYMBOL_NBARRIER_SIGNAL = 44,           /* NBARRIER_SIGNAL  */
  YYSYMBOL_NBARRIER_WAIT = 45,             /* NBARRIER_WAIT  */
  YYSYMBOL_ITYPE = 46,                     /* ITYPE  */
  YYSYMBOL_DECL_DATA_TYPE = 47,            /* DECL_DATA_TYPE  */
  YYSYMBOL_DFTYPE = 48,                    /* DFTYPE  */
  YYSYMBOL_FTYPE = 49,                     /* FTYPE  */
  YYSYMBOL_HFTYPE = 50,                    /* HFTYPE  */
  YYSYMBOL_BFTYPE = 51,                    /* BFTYPE  */
  YYSYMBOL_VTYPE = 52,                     /* VTYPE  */
  YYSYMBOL_COND_MOD = 53,                  /* COND_MOD  */
  YYSYMBOL_LANGLE = 54,                    /* LANGLE  */
  YYSYMBOL_RANGLE = 55,                    /* RANGLE  */
  YYSYMBOL_LBRACK = 56,                    /* LBRACK  */
  YYSYMBOL_RBRACK = 57,                    /* RBRACK  */
  YYSYMBOL_IND_LBRACK = 58,                /* IND_LBRACK  */
  YYSYMBOL_LPAREN = 59,                    /* LPAREN  */
  YYSYMBOL_RPAREN = 60,                    /* RPAREN  */
  YYSYMBOL_LBRACE = 61,                    /* LBRACE  */
  YYSYMBOL_RBRACE = 62,                    /* RBRACE  */
  YYSYMBOL_DOT = 63,                       /* DOT  */
  YYSYMBOL_COMMA = 64,                     /* COMMA  */
  YYSYMBOL_SEMI = 65,                      /* SEMI  */
  YYSYMBOL_COLON = 66,                     /* COLON  */
  YYSYMBOL_SLASH = 67,                     /* SLASH  */
  YYSYMBOL_PERCENT = 68,                   /* PERCENT  */
  YYSYMBOL_EQUALS = 69,                    /* EQUALS  */
  YYSYMBOL_PLUS = 70,                      /* PLUS  */
  YYSYMBOL_MINUS = 71,                     /* MINUS  */
  YYSYMBOL_TIMES = 72,                     /* TIMES  */
  YYSYMBOL_AMP = 73,                       /* AMP  */
  YYSYMBOL_CIRC = 74,                      /* CIRC  */
  YYSYMBOL_PIPE = 75,                      /* PIPE  */
  YYSYMBOL_TILDE = 76,                     /* TILDE  */
  YYSYMBOL_BANG = 77,                      /* BANG  */
  YYSYMBOL_QUESTION = 78,                  /* QUESTION  */
  YYSYMBOL_LEQ = 79,                       /* LEQ  */
  YYSYMBOL_GEQ = 80,                       /* GEQ  */
  YYSYMBOL_EQ = 81,                        /* EQ  */
  YYSYMBOL_NEQ = 82,                       /* NEQ  */
  YYSYMBOL_SHL = 83,                       /* SHL  */
  YYSYMBOL_SHRS = 84,                      /* SHRS  */
  YYSYMBOL_SHRZ = 85,                      /* SHRZ  */
  YYSYMBOL_LABEL = 86,                     /* LABEL  */
  YYSYMBOL_IDENT = 87,                     /* IDENT  */
  YYSYMBOL_BUILTIN_NULL = 88,              /* BUILTIN_NULL  */
  YYSYMBOL_BUILTIN = 89,                   /* BUILTIN  */
  YYSYMBOL_STRING_LIT = 90,                /* STRING_LIT  */
  YYSYMBOL_NEWLINE = 91,                   /* NEWLINE  */
  YYSYMBOL_UNIFORM = 92,                   /* UNIFORM  */
  YYSYMBOL_RTWRITE_OPTION = 93,            /* RTWRITE_OPTION  */
  YYSYMBOL_MEDIA_MODE = 94,                /* MEDIA_MODE  */
  YYSYMBOL_OWORD_MODIFIER = 95,            /* OWORD_MODIFIER  */
  YYSYMBOL_SAMPLER_CHANNEL = 96,           /* SAMPLER_CHANNEL  */
  YYSYMBOL_CHANNEL_OUTPUT = 97,            /* CHANNEL_OUTPUT  */
  YYSYMBOL_EXECMODE = 98,                  /* EXECMODE  */
  YYSYMBOL_CNTRL = 99,                     /* CNTRL  */
  YYSYMBOL_FENCE_OPTIONS = 100,            /* FENCE_OPTIONS  */
  YYSYMBOL_ADDR_ADD_OP = 101,              /* ADDR_ADD_OP  */
  YYSYMBOL_UNARY_LOGIC_OP = 102,           /* UNARY_LOGIC_OP  */
  YYSYMBOL_BINARY_LOGIC_OP = 103,          /* BINARY_LOGIC_OP  */
  YYSYMBOL_TERNARY_LOGIC_OP = 104,         /* TERNARY_LOGIC_OP  */
  YYSYMBOL_QUATERNARY_LOGIC_OP = 105,      /* QUATERNARY_LOGIC_OP  */
  YYSYMBOL_SEL_OP = 106,                   /* SEL_OP  */
  YYSYMBOL_MIN_OP = 107,                   /* MIN_OP  */
  YYSYMBOL_MAX_OP = 108,                   /* MAX_OP  */
  YYSYMBOL_ANTI_TRIG_OP = 109,             /* ANTI_TRIG_OP  */
  YYSYMBOL_MATH2_OP = 110,                 /* MATH2_OP  */
  YYSYMBOL_MATH3_OP = 111,                 /* MATH3_OP  */
  YYSYMBOL_ARITH2_OP = 112,                /* ARITH2_OP  */
  YYSYMBOL_ARITH3_OP = 113,                /* ARITH3_OP  */
  YYSYMBOL_ARITH4_OP = 114,                /* ARITH4_OP  */
  YYSYMBOL_ARITH4_OP2 = 115,               /* ARITH4_OP2  */
  YYSYMBOL_ARITH5_OP2 = 116,               /* ARITH5_OP2  */
  YYSYMBOL_CMP_OP = 117,                   /* CMP_OP  */
  YYSYMBOL_SVM_OP = 118,                   /* SVM_OP  */
  YYSYMBOL_SVM_SCATTER_OP = 119,           /* SVM_SCATTER_OP  */
  YYSYMBOL_SVM_GATHER4SCALED_OP = 120,     /* SVM_GATHER4SCALED_OP  */
  YYSYMBOL_SVM_SCATTER4SCALED_OP = 121,    /* SVM_SCATTER4SCALED_OP  */
  YYSYMBOL_SVM_ATOMIC_OP = 122,            /* SVM_ATOMIC_OP  */
  YYSYMBOL_OWORD_OP = 123,                 /* OWORD_OP  */
  YYSYMBOL_MEDIA_OP = 124,                 /* MEDIA_OP  */
  YYSYMBOL_SCATTER_OP = 125,               /* SCATTER_OP  */
  YYSYMBOL_SCATTER_TYPED_OP = 126,         /* SCATTER_TYPED_OP  */
  YYSYMBOL_SCATTER_SCALED_OP = 127,        /* SCATTER_SCALED_OP  */
  YYSYMBOL_SCATTER4_SCALED_OP = 128,       /* SCATTER4_SCALED_OP  */
  YYSYMBOL_BARRIER_OP = 129,               /* BARRIER_OP  */
  YYSYMBOL_SBARRIER_SIGNAL = 130,          /* SBARRIER_SIGNAL  */
  YYSYMBOL_SBARRIER_WAIT = 131,            /* SBARRIER_WAIT  */
  YYSYMBOL_DWORD_ATOMIC_OP = 132,          /* DWORD_ATOMIC_OP  */
  YYSYMBOL_TYPED_ATOMIC_OP = 133,          /* TYPED_ATOMIC_OP  */
  YYSYMBOL_SAMPLE_OP = 134,                /* SAMPLE_OP  */
  YYSYMBOL_SAMPLE_UNORM_OP = 135,          /* SAMPLE_UNORM_OP  */
  YYSYMBOL_VME_IME_OP = 136,               /* VME_IME_OP  */
  YYSYMBOL_VME_SIC_OP = 137,               /* VME_SIC_OP  */
  YYSYMBOL_VME_FBR_OP = 138,               /* VME_FBR_OP  */
  YYSYMBOL_BRANCH_OP = 139,                /* BRANCH_OP  */
  YYSYMBOL_RET_OP = 140,                   /* RET_OP  */
  YYSYMBOL_IFCALL = 141,                   /* IFCALL  */
  YYSYMBOL_FCALL = 142,                    /* FCALL  */
  YYSYMBOL_FADDR = 143,                    /* FADDR  */
  YYSYMBOL_SWITCHJMP_OP = 144,             /* SWITCHJMP_OP  */
  YYSYMBOL_MOVS_OP = 145,                  /* MOVS_OP  */
  YYSYMBOL_SETP_OP = 146,                  /* SETP_OP  */
  YYSYMBOL_MOV_OP = 147,                   /* MOV_OP  */
  YYSYMBOL_FILE_OP = 148,                  /* FILE_OP  */
  YYSYMBOL_LOC_OP = 149,                   /* LOC_OP  */
  YYSYMBOL_CACHE_FLUSH_OP = 150,           /* CACHE_FLUSH_OP  */
  YYSYMBOL_WAIT_OP = 151,                  /* WAIT_OP  */
  YYSYMBOL_FENCE_GLOBAL_OP = 152,          /* FENCE_GLOBAL_OP  */
  YYSYMBOL_FENCE_LOCAL_OP = 153,           /* FENCE_LOCAL_OP  */
  YYSYMBOL_FENCE_SW_OP = 154,              /* FENCE_SW_OP  */
  YYSYMBOL_YIELD_OP = 155,                 /* YIELD_OP  */
  YYSYMBOL_SAMPLE_3D_OP = 156,             /* SAMPLE_3D_OP  */
  YYSYMBOL_LOAD_3D_OP = 157,               /* LOAD_3D_OP  */
  YYSYMBOL_SAMPLE4_3D_OP = 158,            /* SAMPLE4_3D_OP  */
  YYSYMBOL_RESINFO_OP_3D = 159,            /* RESINFO_OP_3D  */
  YYSYMBOL_SAMPLEINFO_OP_3D = 160,         /* SAMPLEINFO_OP_3D  */
  YYSYMBOL_RTWRITE_OP_3D = 161,            /* RTWRITE_OP_3D  */
  YYSYMBOL_URBWRITE_OP_3D = 162,           /* URBWRITE_OP_3D  */
  YYSYMBOL_LIFETIME_START_OP = 163,        /* LIFETIME_START_OP  */
  YYSYMBOL_LIFETIME_END_OP = 164,          /* LIFETIME_END_OP  */
  YYSYMBOL_AVS_OP = 165,                   /* AVS_OP  */
  YYSYMBOL_BREAKPOINT_OP = 166,            /* BREAKPOINT_OP  */
  YYSYMBOL_CALL_OP = 167,                  /* CALL_OP  */
  YYSYMBOL_PRED_CNTL = 168,                /* PRED_CNTL  */
  YYSYMBOL_F32_LIT = 169,                  /* F32_LIT  */
  YYSYMBOL_F64_LIT = 170,                  /* F64_LIT  */
  YYSYMBOL_DEC_LIT = 171,                  /* DEC_LIT  */
  YYSYMBOL_HEX_LIT = 172,                  /* HEX_LIT  */
  YYSYMBOL_BUILTIN_SIZEOF = 173,           /* BUILTIN_SIZEOF  */
  YYSYMBOL_BUILTIN_DISPATCH_SIMD_SIZE = 174, /* BUILTIN_DISPATCH_SIMD_SIZE  */
  YYSYMBOL_QW_SCATTER_OP = 175,            /* QW_SCATTER_OP  */
  YYSYMBOL_LSC_CACHING_OPT = 176,          /* LSC_CACHING_OPT  */
  YYSYMBOL_LSC_ADDR_SIZE_TK = 177,         /* LSC_ADDR_SIZE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK = 178,        /* LSC_DATA_SHAPE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_CHMASK = 179, /* LSC_DATA_SHAPE_TK_CHMASK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_BLOCK2D = 180, /* LSC_DATA_SHAPE_TK_BLOCK2D  */
  YYSYMBOL_LSC_AM_FLAT = 181,              /* LSC_AM_FLAT  */
  YYSYMBOL_LSC_AM_BTI = 182,               /* LSC_AM_BTI  */
  YYSYMBOL_LSC_AM_BSS = 183,               /* LSC_AM_BSS  */
  YYSYMBOL_LSC_AM_SS = 184,                /* LSC_AM_SS  */
  YYSYMBOL_LSC_AM_ARG = 185,               /* LSC_AM_ARG  */
  YYSYMBOL_LSC_FENCE_OP_TYPE = 186,        /* LSC_FENCE_OP_TYPE  */
  YYSYMBOL_LSC_FENCE_SCOPE = 187,          /* LSC_FENCE_SCOPE  */
  YYSYMBOL_LSC_SFID_UNTYPED_TOKEN = 188,   /* LSC_SFID_UNTYPED_TOKEN  */
  YYSYMBOL_LSC_SFID_TYPED_TOKEN = 189,     /* LSC_SFID_TYPED_TOKEN  */
  YYSYMBOL_LSC_LOAD_MNEMONIC = 190,        /* LSC_LOAD_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_STRIDED_MNEMONIC = 191, /* LSC_LOAD_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_BLOCK2D_MNEMONIC = 192, /* LSC_LOAD_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_STORE_MNEMONIC = 193,       /* LSC_STORE_MNEMONIC  */
  YYSYMBOL_LSC_STORE_STRIDED_MNEMONIC = 194, /* LSC_STORE_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_STORE_BLOCK2D_MNEMONIC = 195, /* LSC_STORE_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_ATOMIC_MNEMONIC = 196,      /* LSC_ATOMIC_MNEMONIC  */
  YYSYMBOL_LSC_READ_STATE_INFO_MNEMONIC = 197, /* LSC_READ_STATE_INFO_MNEMONIC  */
  YYSYMBOL_LSC_FENCE_MNEMONIC = 198,       /* LSC_FENCE_MNEMONIC  */
  YYSYMBOL_FCVT_OP = 199,                  /* FCVT_OP  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_TYPED_BLOCK2D = 200, /* LSC_DATA_SHAPE_TK_TYPED_BLOCK2D  */
  YYSYMBOL_YYACCEPT = 201,                 /* $accept  */
  YYSYMBOL_Listing = 202,                  /* Listing  */
  YYSYMBOL_ListingHeader = 203,            /* ListingHeader  */
  YYSYMBOL_Statements = 204,               /* Statements  */
  YYSYMBOL_Newlines = 205,                 /* Newlines  */
  YYSYMBOL_NewlinesOpt = 206,              /* NewlinesOpt  */
  YYSYMBOL_Statement = 207,                /* Statement  */
  YYSYMBOL_Scope = 208,                    /* Scope  */
  YYSYMBOL_ScopeStart = 209,               /* ScopeStart  */
  YYSYMBOL_ScopeEnd = 210,                 /* ScopeEnd  */
  YYSYMBOL_IdentOrStringLit = 211,         /* IdentOrStringLit  */
  YYSYMBOL_DirectiveKernel = 212,          /* DirectiveKernel  */
  YYSYMBOL_DirectiveGlobalFunction = 213,  /* DirectiveGlobalFunction  */
  YYSYMBOL_DirectiveVersion = 214,         /* DirectiveVersion  */
  YYSYMBOL_DirectiveDecl = 215,            /* DirectiveDecl  */
  YYSYMBOL_DeclFunction = 216,             /* DeclFunction  */
  YYSYMBOL_DeclVariable = 217,             /* DeclVariable  */
  YYSYMBOL_DeclAddress = 218,              /* DeclAddress  */
  YYSYMBOL_DeclPredicate = 219,            /* DeclPredicate  */
  YYSYMBOL_DeclSampler = 220,              /* DeclSampler  */
  YYSYMBOL_VNameEqOpt = 221,               /* VNameEqOpt  */
  YYSYMBOL_DeclSurface = 222,              /* DeclSurface  */
  YYSYMBOL_DirectiveInput = 223,           /* DirectiveInput  */
  YYSYMBOL_DirectiveImplicitInput = 224,   /* DirectiveImplicitInput  */
  YYSYMBOL_InputOffset = 225,              /* InputOffset  */
  YYSYMBOL_InputSize = 226,                /* InputSize  */
  YYSYMBOL_DirectiveAttr = 227,            /* DirectiveAttr  */
  YYSYMBOL_DirectiveFunc = 228,            /* DirectiveFunc  */
  YYSYMBOL_AlignAttrOpt = 229,             /* AlignAttrOpt  */
  YYSYMBOL_Align = 230,                    /* Align  */
  YYSYMBOL_AliasAttrOpt = 231,             /* AliasAttrOpt  */
  YYSYMBOL_OneAttr = 232,                  /* OneAttr  */
  YYSYMBOL_AttrOpt = 233,                  /* AttrOpt  */
  YYSYMBOL_GenAttrOpt = 234,               /* GenAttrOpt  */
  YYSYMBOL_Instruction = 235,              /* Instruction  */
  YYSYMBOL_Label = 236,                    /* Label  */
  YYSYMBOL_LogicInstruction = 237,         /* LogicInstruction  */
  YYSYMBOL_UnaryLogicInstruction = 238,    /* UnaryLogicInstruction  */
  YYSYMBOL_MathInstruction_2OPND = 239,    /* MathInstruction_2OPND  */
  YYSYMBOL_MathInstruction_3OPND = 240,    /* MathInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_2OPND = 241,   /* ArithInstruction_2OPND  */
  YYSYMBOL_ArithInstruction_3OPND = 242,   /* ArithInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_4OPND = 243,   /* ArithInstruction_4OPND  */
  YYSYMBOL_DpasInstruction = 244,          /* DpasInstruction  */
  YYSYMBOL_BfnInstruction = 245,           /* BfnInstruction  */
  YYSYMBOL_QwScatterInstruction = 246,     /* QwScatterInstruction  */
  YYSYMBOL_FCvtInstruction = 247,          /* FCvtInstruction  */
  YYSYMBOL_AntiTrigInstruction = 248,      /* AntiTrigInstruction  */
  YYSYMBOL_AddrAddInstruction = 249,       /* AddrAddInstruction  */
  YYSYMBOL_SetpInstruction = 250,          /* SetpInstruction  */
  YYSYMBOL_SelInstruction = 251,           /* SelInstruction  */
  YYSYMBOL_MinInstruction = 252,           /* MinInstruction  */
  YYSYMBOL_MaxInstruction = 253,           /* MaxInstruction  */
  YYSYMBOL_MovInstruction = 254,           /* MovInstruction  */
  YYSYMBOL_BreakpointInstruction = 255,    /* BreakpointInstruction  */
  YYSYMBOL_MovsInstruction = 256,          /* MovsInstruction  */
  YYSYMBOL_CmpInstruction = 257,           /* CmpInstruction  */
  YYSYMBOL_MediaInstruction = 258,         /* MediaInstruction  */
  YYSYMBOL_MediaInstructionPlaneID = 259,  /* MediaInstructionPlaneID  */
  YYSYMBOL_ScatterInstruction = 260,       /* ScatterInstruction  */
  YYSYMBOL_ScatterTypedInstruction = 261,  /* ScatterTypedInstruction  */
  YYSYMBOL_Scatter4ScaledInstruction = 262, /* Scatter4ScaledInstruction  */
  YYSYMBOL_ScatterScaledInstruction = 263, /* ScatterScaledInstruction  */
  YYSYMBOL_SynchronizationInstruction = 264, /* SynchronizationInstruction  */
  YYSYMBOL_DwordAtomicInstruction = 265,   /* DwordAtomicInstruction  */
  YYSYMBOL_TypedAtomicInstruction = 266,   /* TypedAtomicInstruction  */
  YYSYMBOL_Atomic16Opt = 267,              /* Atomic16Opt  */
  YYSYMBOL_SampleUnormInstruction = 268,   /* SampleUnormInstruction  */
  YYSYMBOL_SampleInstruction = 269,        /* SampleInstruction  */
  YYSYMBOL_SamplerAddrOperand = 270,       /* SamplerAddrOperand  */
  YYSYMBOL_Sample3dInstruction = 271,      /* Sample3dInstruction  */
  YYSYMBOL_CPSEnableOpt = 272,             /* CPSEnableOpt  */
  YYSYMBOL_NonUniformSamplerEnableOpt = 273, /* NonUniformSamplerEnableOpt  */
  YYSYMBOL_Load3dInstruction = 274,        /* Load3dInstruction  */
  YYSYMBOL_Gather43dInstruction = 275,     /* Gather43dInstruction  */
  YYSYMBOL_PixelNullMaskEnableOpt = 276,   /* PixelNullMaskEnableOpt  */
  YYSYMBOL_ResInfo3dInstruction = 277,     /* ResInfo3dInstruction  */
  YYSYMBOL_SampleInfo3dInstruction = 278,  /* SampleInfo3dInstruction  */
  YYSYMBOL_RTWriteOperands = 279,          /* RTWriteOperands  */
  YYSYMBOL_RTWriteInstruction = 280,       /* RTWriteInstruction  */
  YYSYMBOL_RTWriteModeOpt = 281,           /* RTWriteModeOpt  */
  YYSYMBOL_URBWriteInstruction = 282,      /* URBWriteInstruction  */
  YYSYMBOL_AVSInstruction = 283,           /* AVSInstruction  */
  YYSYMBOL_VMEInstruction = 284,           /* VMEInstruction  */
  YYSYMBOL_OwordInstruction = 285,         /* OwordInstruction  */
  YYSYMBOL_SvmInstruction = 286,           /* SvmInstruction  */
  YYSYMBOL_AtomicBitwidthOpt = 287,        /* AtomicBitwidthOpt  */
  YYSYMBOL_LscInstruction = 288,           /* LscInstruction  */
  YYSYMBOL_LscUntypedLoad = 289,           /* LscUntypedLoad  */
  YYSYMBOL_LscUntypedStridedLoad = 290,    /* LscUntypedStridedLoad  */
  YYSYMBOL_LscUntypedBlock2dLoad = 291,    /* LscUntypedBlock2dLoad  */
  YYSYMBOL_LscUntypedStore = 292,          /* LscUntypedStore  */
  YYSYMBOL_LscUntypedStridedStore = 293,   /* LscUntypedStridedStore  */
  YYSYMBOL_LscUntypedBlock2dStore = 294,   /* LscUntypedBlock2dStore  */
  YYSYMBOL_LscUntypedAtomic = 295,         /* LscUntypedAtomic  */
  YYSYMBOL_LscTypedLoad = 296,             /* LscTypedLoad  */
  YYSYMBOL_LscTypedStore = 297,            /* LscTypedStore  */
  YYSYMBOL_LscTypedAtomic = 298,           /* LscTypedAtomic  */
  YYSYMBOL_LscTypedReadStateInfo = 299,    /* LscTypedReadStateInfo  */
  YYSYMBOL_LscFence = 300,                 /* LscFence  */
  YYSYMBOL_LscSfid = 301,                  /* LscSfid  */
  YYSYMBOL_LscCacheOpts = 302,             /* LscCacheOpts  */
  YYSYMBOL_LscUntypedAddrOperand = 303,    /* LscUntypedAddrOperand  */
  YYSYMBOL_LscUntypedStridedAddrOperand = 304, /* LscUntypedStridedAddrOperand  */
  YYSYMBOL_LscUntypedBlock2dAddrOperand = 305, /* LscUntypedBlock2dAddrOperand  */
  YYSYMBOL_LscTypedAddrWithOffsetOperand = 306, /* LscTypedAddrWithOffsetOperand  */
  YYSYMBOL_LscTypedAddrWithOffsetOperandList = 307, /* LscTypedAddrWithOffsetOperandList  */
  YYSYMBOL_LscTypedAddrOperandWithOffsets = 308, /* LscTypedAddrOperandWithOffsets  */
  YYSYMBOL_LscAddrImmOffsetOpt = 309,      /* LscAddrImmOffsetOpt  */
  YYSYMBOL_LscAddrImmScaleOpt = 310,       /* LscAddrImmScaleOpt  */
  YYSYMBOL_LscAddrModelOpt = 311,          /* LscAddrModelOpt  */
  YYSYMBOL_LscAddrModelStateful = 312,     /* LscAddrModelStateful  */
  YYSYMBOL_LscVectorOpRegOrImm32 = 313,    /* LscVectorOpRegOrImm32  */
  YYSYMBOL_LscVectorOpImm32 = 314,         /* LscVectorOpImm32  */
  YYSYMBOL_LscVectorOpReg = 315,           /* LscVectorOpReg  */
  YYSYMBOL_LscDataOperand = 316,           /* LscDataOperand  */
  YYSYMBOL_LscDataOperand2D = 317,         /* LscDataOperand2D  */
  YYSYMBOL_LscPayloadReg = 318,            /* LscPayloadReg  */
  YYSYMBOL_LscPayloadNonNullReg = 319,     /* LscPayloadNonNullReg  */
  YYSYMBOL_LscInstructionXe2 = 320,        /* LscInstructionXe2  */
  YYSYMBOL_LscTypedBlock2dLoad = 321,      /* LscTypedBlock2dLoad  */
  YYSYMBOL_LscTypedBlock2dStore = 322,     /* LscTypedBlock2dStore  */
  YYSYMBOL_LscTypedBlock2dAddrOperand = 323, /* LscTypedBlock2dAddrOperand  */
  YYSYMBOL_LscDataOperandTyped2D = 324,    /* LscDataOperandTyped2D  */
  YYSYMBOL_LscUntypedApndCtrAtomic = 325,  /* LscUntypedApndCtrAtomic  */
  YYSYMBOL_SwitchLabels = 326,             /* SwitchLabels  */
  YYSYMBOL_BranchInstruction = 327,        /* BranchInstruction  */
  YYSYMBOL_FILE = 328,                     /* FILE  */
  YYSYMBOL_LOC = 329,                      /* LOC  */
  YYSYMBOL_RawSendInstruction = 330,       /* RawSendInstruction  */
  YYSYMBOL_LifetimeStartInst = 331,        /* LifetimeStartInst  */
  YYSYMBOL_LifetimeEndInst = 332,          /* LifetimeEndInst  */
  YYSYMBOL_RawSendsInstruction = 333,      /* RawSendsInstruction  */
  YYSYMBOL_NullaryInstruction = 334,       /* NullaryInstruction  */
  YYSYMBOL_OwordModifier = 335,            /* OwordModifier  */
  YYSYMBOL_Predicate = 336,                /* Predicate  */
  YYSYMBOL_PredSign = 337,                 /* PredSign  */
  YYSYMBOL_PredCtrlOpt = 338,              /* PredCtrlOpt  */
  YYSYMBOL_SatModOpt = 339,                /* SatModOpt  */
  YYSYMBOL_SrcModifier = 340,              /* SrcModifier  */
  YYSYMBOL_ConditionalModifier = 341,      /* ConditionalModifier  */
  YYSYMBOL_VecDstOperand_A = 342,          /* VecDstOperand_A  */
  YYSYMBOL_VecDstOperand_G = 343,          /* VecDstOperand_G  */
  YYSYMBOL_VecDstOperand_G_I = 344,        /* VecDstOperand_G_I  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A_AO = 345, /* VecSrcOperand_G_I_IMM_A_AO  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A = 346,  /* VecSrcOperand_G_I_IMM_A  */
  YYSYMBOL_VecSrcOperand_G_I_IMM = 347,    /* VecSrcOperand_G_I_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM = 348,      /* VecSrcOperand_G_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM_AO = 349,   /* VecSrcOperand_G_IMM_AO  */
  YYSYMBOL_VecSrcOperand_G_A = 350,        /* VecSrcOperand_G_A  */
  YYSYMBOL_VecSrcOperand_G_A_AO = 351,     /* VecSrcOperand_G_A_AO  */
  YYSYMBOL_VecSrcOperand_G = 352,          /* VecSrcOperand_G  */
  YYSYMBOL_VecSrcOpndSimple = 353,         /* VecSrcOpndSimple  */
  YYSYMBOL_VMEOpndIME = 354,               /* VMEOpndIME  */
  YYSYMBOL_VMEOpndFBR = 355,               /* VMEOpndFBR  */
  YYSYMBOL_SrcStateOperand = 356,          /* SrcStateOperand  */
  YYSYMBOL_DstStateOperand = 357,          /* DstStateOperand  */
  YYSYMBOL_RawOperand = 358,               /* RawOperand  */
  YYSYMBOL_RawOperandNonNull = 359,        /* RawOperandNonNull  */
  YYSYMBOL_RawOperandOffsetSuffix = 360,   /* RawOperandOffsetSuffix  */
  YYSYMBOL_RawOperandArray = 361,          /* RawOperandArray  */
  YYSYMBOL_DstAddrOperand = 362,           /* DstAddrOperand  */
  YYSYMBOL_DstGeneralOperand = 363,        /* DstGeneralOperand  */
  YYSYMBOL_DstIndirectOperand = 364,       /* DstIndirectOperand  */
  YYSYMBOL_SrcAddrOfOperand = 365,         /* SrcAddrOfOperand  */
  YYSYMBOL_AddrOfVar = 366,                /* AddrOfVar  */
  YYSYMBOL_SrcAddrOperand = 367,           /* SrcAddrOperand  */
  YYSYMBOL_SrcGeneralOperand = 368,        /* SrcGeneralOperand  */
  YYSYMBOL_SrcImmOperand = 369,            /* SrcImmOperand  */
  YYSYMBOL_FloatLit = 370,                 /* FloatLit  */
  YYSYMBOL_DoubleFloatLit = 371,           /* DoubleFloatLit  */
  YYSYMBOL_SrcIndirectOperand = 372,       /* SrcIndirectOperand  */
  YYSYMBOL_DstRegion = 373,                /* DstRegion  */
  YYSYMBOL_SrcRegionDirect = 374,          /* SrcRegionDirect  */
  YYSYMBOL_SrcRegionIndirect = 375,        /* SrcRegionIndirect  */
  YYSYMBOL_IndirectVarAccess = 376,        /* IndirectVarAccess  */
  YYSYMBOL_TwoDimOffset = 377,             /* TwoDimOffset  */
  YYSYMBOL_PredVar = 378,                  /* PredVar  */
  YYSYMBOL_AddrVarAccess = 379,            /* AddrVarAccess  */
  YYSYMBOL_AddrVarAccessWithWidth = 380,   /* AddrVarAccessWithWidth  */
  YYSYMBOL_SIMDMode = 381,                 /* SIMDMode  */
  YYSYMBOL_ElemNum = 382,                  /* ElemNum  */
  YYSYMBOL_ExecSize = 383,                 /* ExecSize  */
  YYSYMBOL_ExecSizeInt = 384,              /* ExecSizeInt  */
  YYSYMBOL_Var = 385,                      /* Var  */
  YYSYMBOL_VarNonNull = 386,               /* VarNonNull  */
  YYSYMBOL_IntExp = 387,                   /* IntExp  */
  YYSYMBOL_IntExpCond = 388,               /* IntExpCond  */
  YYSYMBOL_IntExpAND = 389,                /* IntExpAND  */
  YYSYMBOL_IntExpXOR = 390,                /* IntExpXOR  */
  YYSYMBOL_IntExpOR = 391,                 /* IntExpOR  */
  YYSYMBOL_IntExpCmp = 392,                /* IntExpCmp  */
  YYSYMBOL_IntExpRel = 393,                /* IntExpRel  */
  YYSYMBOL_IntExpNRA = 394,                /* IntExpNRA  */
  YYSYMBOL_IntExpShift = 395,              /* IntExpShift  */
  YYSYMBOL_IntExpAdd = 396,                /* IntExpAdd  */
  YYSYMBOL_IntExpMul = 397,                /* IntExpMul  */
  YYSYMBOL_IntExpUnr = 398,                /* IntExpUnr  */
  YYSYMBOL_IntExpPrim = 399,               /* IntExpPrim  */
  YYSYMBOL_DataType = 400,                 /* DataType  */
  YYSYMBOL_DataTypeIntOrVector = 401       /* DataTypeIntOrVector  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3441

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  201
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  201
/* YYNRULES -- Number of rules.  */
#define YYNRULES  459
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1180

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   455


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   669,   669,   674,   676,   676,   678,   678,   679,   679,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     696,   697,   698,   702,   706,   709,   709,   716,   724,   732,
     739,   740,   741,   742,   743,   744,   746,   753,   761,   769,
     776,   780,   780,   783,   791,   796,   808,   815,   823,   823,
     824,   830,   834,   838,   842,   847,   853,   853,   855,   859,
     865,   873,   879,   884,   889,   895,   899,   903,   909,   914,
     920,   924,   934,   935,   936,   937,   938,   939,   940,   941,
     942,   943,   944,   945,   946,   947,   948,   949,   950,   951,
     952,   953,   954,   955,   956,   957,   958,   959,   960,   961,
     962,   963,   964,   965,   966,   967,   968,   969,   970,   971,
     972,   973,   974,   975,   976,   977,   978,   979,   980,   981,
     982,   983,   984,   985,   987,   991,   997,  1002,  1008,  1015,
    1021,  1028,  1035,  1042,  1049,  1059,  1068,  1075,  1082,  1091,
    1101,  1107,  1114,  1120,  1129,  1139,  1146,  1153,  1161,  1170,
    1177,  1184,  1190,  1196,  1202,  1208,  1226,  1233,  1243,  1251,
    1258,  1265,  1274,  1283,  1292,  1300,  1303,  1306,  1309,  1312,
    1315,  1320,  1327,  1335,  1336,  1342,  1355,  1363,  1370,  1375,
    1380,  1397,  1397,  1399,  1399,  1402,  1419,  1437,  1437,  1440,
    1448,  1456,  1459,  1463,  1469,  1482,  1482,  1486,  1494,  1506,
    1522,  1528,  1541,  1549,  1556,  1564,  1570,  1576,  1582,  1588,
    1595,  1596,  1605,  1606,  1607,  1609,  1610,  1611,  1613,  1616,
    1617,  1618,  1619,  1621,  1648,  1680,  1710,  1738,  1764,  1792,
    1821,  1855,  1899,  1944,  1980,  2019,  2024,  2024,  2027,  2028,
    2032,  2041,  2047,  2056,  2076,  2096,  2103,  2107,  2110,  2115,
    2118,  2123,  2129,  2137,  2150,  2151,  2152,  2157,  2158,  2161,
    2162,  2163,  2164,  2168,  2171,  2174,  2177,  2180,  2183,  2188,
    2188,  2192,  2202,  2210,  2218,  2232,  2236,  2242,  2247,  2250,
    2254,  2257,  2263,  2265,  2266,  2278,  2307,  2329,  2341,  2352,
    2361,  2383,  2386,  2389,  2396,  2400,  2404,  2408,  2414,  2419,
    2426,  2433,  2438,  2443,  2449,  2456,  2463,  2469,  2475,  2483,
    2491,  2499,  2509,  2514,  2519,  2524,  2529,  2534,  2539,  2544,
    2549,  2549,  2555,  2560,  2565,  2565,  2567,  2567,  2570,  2570,
    2573,  2574,  2575,  2576,  2578,  2578,  2583,  2584,  2586,  2587,
    2591,  2592,  2595,  2596,  2599,  2600,  2601,  2604,  2605,  2608,
    2609,  2610,  2613,  2614,  2617,  2618,  2620,  2622,  2632,  2639,
    2647,  2655,  2674,  2686,  2693,  2705,  2710,  2717,  2722,  2730,
    2738,  2744,  2749,  2771,  2775,  2781,  2791,  2799,  2806,  2816,
    2822,  2829,  2833,  2838,  2842,  2848,  2849,  2856,  2864,  2865,
    2871,  2881,  2889,  2898,  2916,  2930,  2933,  2944,  2955,  2960,
    2965,  2973,  2982,  2994,  3008,  3010,  3021,  3033,  3039,  3047,
    3056,  3056,  3057,  3057,  3060,  3062,  3063,  3065,  3066,  3068,
    3069,  3071,  3072,  3074,  3075,  3076,  3078,  3079,  3080,  3081,
    3082,  3101,  3104,  3105,  3106,  3107,  3109,  3110,  3111,  3113,
    3114,  3119,  3124,  3126,  3127,  3128,  3129,  3133,  3134,  3136,
    3140,  3144,  3150,  3159,  3160,  3161,  3162,  3163,  3165,  3166
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ALIGN_KEYWORD",
  "ATOMIC_SUB_OP", "DIRECTIVE_DECL", "DIRECTIVE_FUNC",
  "DIRECTIVE_FUNCDECL", "DIRECTIVE_GLOBAL_FUNC", "DIRECTIVE_IMPLICIT",
  "DIRECTIVE_INPUT", "DIRECTIVE_KERNEL", "DIRECTIVE_KERNEL_ATTR",
  "DIRECTIVE_VERSION", "ALIAS_EQ", "ALIGN_EQ", "ATTR_EQ", "OFFSET_EQ",
  "NUM_ELTS_EQ", "V_NAME_EQ", "SIZE_EQ", "V_TYPE_EQ_G", "V_TYPE_EQ_P",
  "V_TYPE_EQ_A", "V_TYPE_EQ_S", "V_TYPE_EQ_T", "CPS",
  "NON_UNIFORM_SAMPLER", "PIXEL_NULL_MASK", "RAW_SEND_STRING",
  "RAW_SENDC_STRING", "RAW_SENDS_STRING", "RAW_SENDS_EOT_STRING",
  "RAW_SENDSC_STRING", "RAW_SENDSC_EOT_STRING", "SAT", "SRCMOD_ABS",
  "SRCMOD_NEG", "SRCMOD_NEGABS", "SRCMOD_NOT", "BFN_OP", "DPAS_OP",
  "SVM_ALIGNED", "SVM_UNALIGNED", "NBARRIER_SIGNAL", "NBARRIER_WAIT",
  "ITYPE", "DECL_DATA_TYPE", "DFTYPE", "FTYPE", "HFTYPE", "BFTYPE",
  "VTYPE", "COND_MOD", "LANGLE", "RANGLE", "LBRACK", "RBRACK",
  "IND_LBRACK", "LPAREN", "RPAREN", "LBRACE", "RBRACE", "DOT", "COMMA",
  "SEMI", "COLON", "SLASH", "PERCENT", "EQUALS", "PLUS", "MINUS", "TIMES",
  "AMP", "CIRC", "PIPE", "TILDE", "BANG", "QUESTION", "LEQ", "GEQ", "EQ",
  "NEQ", "SHL", "SHRS", "SHRZ", "LABEL", "IDENT", "BUILTIN_NULL",
  "BUILTIN", "STRING_LIT", "NEWLINE", "UNIFORM", "RTWRITE_OPTION",
  "MEDIA_MODE", "OWORD_MODIFIER", "SAMPLER_CHANNEL", "CHANNEL_OUTPUT",
  "EXECMODE", "CNTRL", "FENCE_OPTIONS", "ADDR_ADD_OP", "UNARY_LOGIC_OP",
  "BINARY_LOGIC_OP", "TERNARY_LOGIC_OP", "QUATERNARY_LOGIC_OP", "SEL_OP",
  "MIN_OP", "MAX_OP", "ANTI_TRIG_OP", "MATH2_OP", "MATH3_OP", "ARITH2_OP",
  "ARITH3_OP", "ARITH4_OP", "ARITH4_OP2", "ARITH5_OP2", "CMP_OP", "SVM_OP",
  "SVM_SCATTER_OP", "SVM_GATHER4SCALED_OP", "SVM_SCATTER4SCALED_OP",
  "SVM_ATOMIC_OP", "OWORD_OP", "MEDIA_OP", "SCATTER_OP",
  "SCATTER_TYPED_OP", "SCATTER_SCALED_OP", "SCATTER4_SCALED_OP",
  "BARRIER_OP", "SBARRIER_SIGNAL", "SBARRIER_WAIT", "DWORD_ATOMIC_OP",
  "TYPED_ATOMIC_OP", "SAMPLE_OP", "SAMPLE_UNORM_OP", "VME_IME_OP",
  "VME_SIC_OP", "VME_FBR_OP", "BRANCH_OP", "RET_OP", "IFCALL", "FCALL",
  "FADDR", "SWITCHJMP_OP", "MOVS_OP", "SETP_OP", "MOV_OP", "FILE_OP",
  "LOC_OP", "CACHE_FLUSH_OP", "WAIT_OP", "FENCE_GLOBAL_OP",
  "FENCE_LOCAL_OP", "FENCE_SW_OP", "YIELD_OP", "SAMPLE_3D_OP",
  "LOAD_3D_OP", "SAMPLE4_3D_OP", "RESINFO_OP_3D", "SAMPLEINFO_OP_3D",
  "RTWRITE_OP_3D", "URBWRITE_OP_3D", "LIFETIME_START_OP",
  "LIFETIME_END_OP", "AVS_OP", "BREAKPOINT_OP", "CALL_OP", "PRED_CNTL",
  "F32_LIT", "F64_LIT", "DEC_LIT", "HEX_LIT", "BUILTIN_SIZEOF",
  "BUILTIN_DISPATCH_SIMD_SIZE", "QW_SCATTER_OP", "LSC_CACHING_OPT",
  "LSC_ADDR_SIZE_TK", "LSC_DATA_SHAPE_TK", "LSC_DATA_SHAPE_TK_CHMASK",
  "LSC_DATA_SHAPE_TK_BLOCK2D", "LSC_AM_FLAT", "LSC_AM_BTI", "LSC_AM_BSS",
  "LSC_AM_SS", "LSC_AM_ARG", "LSC_FENCE_OP_TYPE", "LSC_FENCE_SCOPE",
  "LSC_SFID_UNTYPED_TOKEN", "LSC_SFID_TYPED_TOKEN", "LSC_LOAD_MNEMONIC",
  "LSC_LOAD_STRIDED_MNEMONIC", "LSC_LOAD_BLOCK2D_MNEMONIC",
  "LSC_STORE_MNEMONIC", "LSC_STORE_STRIDED_MNEMONIC",
  "LSC_STORE_BLOCK2D_MNEMONIC", "LSC_ATOMIC_MNEMONIC",
  "LSC_READ_STATE_INFO_MNEMONIC", "LSC_FENCE_MNEMONIC", "FCVT_OP",
  "LSC_DATA_SHAPE_TK_TYPED_BLOCK2D", "$accept", "Listing", "ListingHeader",
  "Statements", "Newlines", "NewlinesOpt", "Statement", "Scope",
  "ScopeStart", "ScopeEnd", "IdentOrStringLit", "DirectiveKernel",
  "DirectiveGlobalFunction", "DirectiveVersion", "DirectiveDecl",
  "DeclFunction", "DeclVariable", "DeclAddress", "DeclPredicate",
  "DeclSampler", "VNameEqOpt", "DeclSurface", "DirectiveInput",
  "DirectiveImplicitInput", "InputOffset", "InputSize", "DirectiveAttr",
  "DirectiveFunc", "AlignAttrOpt", "Align", "AliasAttrOpt", "OneAttr",
  "AttrOpt", "GenAttrOpt", "Instruction", "Label", "LogicInstruction",
  "UnaryLogicInstruction", "MathInstruction_2OPND",
  "MathInstruction_3OPND", "ArithInstruction_2OPND",
  "ArithInstruction_3OPND", "ArithInstruction_4OPND", "DpasInstruction",
  "BfnInstruction", "QwScatterInstruction", "FCvtInstruction",
  "AntiTrigInstruction", "AddrAddInstruction", "SetpInstruction",
  "SelInstruction", "MinInstruction", "MaxInstruction", "MovInstruction",
  "BreakpointInstruction", "MovsInstruction", "CmpInstruction",
  "MediaInstruction", "MediaInstructionPlaneID", "ScatterInstruction",
  "ScatterTypedInstruction", "Scatter4ScaledInstruction",
  "ScatterScaledInstruction", "SynchronizationInstruction",
  "DwordAtomicInstruction", "TypedAtomicInstruction", "Atomic16Opt",
  "SampleUnormInstruction", "SampleInstruction", "SamplerAddrOperand",
  "Sample3dInstruction", "CPSEnableOpt", "NonUniformSamplerEnableOpt",
  "Load3dInstruction", "Gather43dInstruction", "PixelNullMaskEnableOpt",
  "ResInfo3dInstruction", "SampleInfo3dInstruction", "RTWriteOperands",
  "RTWriteInstruction", "RTWriteModeOpt", "URBWriteInstruction",
  "AVSInstruction", "VMEInstruction", "OwordInstruction", "SvmInstruction",
  "AtomicBitwidthOpt", "LscInstruction", "LscUntypedLoad",
  "LscUntypedStridedLoad", "LscUntypedBlock2dLoad", "LscUntypedStore",
  "LscUntypedStridedStore", "LscUntypedBlock2dStore", "LscUntypedAtomic",
  "LscTypedLoad", "LscTypedStore", "LscTypedAtomic",
  "LscTypedReadStateInfo", "LscFence", "LscSfid", "LscCacheOpts",
  "LscUntypedAddrOperand", "LscUntypedStridedAddrOperand",
  "LscUntypedBlock2dAddrOperand", "LscTypedAddrWithOffsetOperand",
  "LscTypedAddrWithOffsetOperandList", "LscTypedAddrOperandWithOffsets",
  "LscAddrImmOffsetOpt", "LscAddrImmScaleOpt", "LscAddrModelOpt",
  "LscAddrModelStateful", "LscVectorOpRegOrImm32", "LscVectorOpImm32",
  "LscVectorOpReg", "LscDataOperand", "LscDataOperand2D", "LscPayloadReg",
  "LscPayloadNonNullReg", "LscInstructionXe2", "LscTypedBlock2dLoad",
  "LscTypedBlock2dStore", "LscTypedBlock2dAddrOperand",
  "LscDataOperandTyped2D", "LscUntypedApndCtrAtomic", "SwitchLabels",
  "BranchInstruction", "FILE", "LOC", "RawSendInstruction",
  "LifetimeStartInst", "LifetimeEndInst", "RawSendsInstruction",
  "NullaryInstruction", "OwordModifier", "Predicate", "PredSign",
  "PredCtrlOpt", "SatModOpt", "SrcModifier", "ConditionalModifier",
  "VecDstOperand_A", "VecDstOperand_G", "VecDstOperand_G_I",
  "VecSrcOperand_G_I_IMM_A_AO", "VecSrcOperand_G_I_IMM_A",
  "VecSrcOperand_G_I_IMM", "VecSrcOperand_G_IMM", "VecSrcOperand_G_IMM_AO",
  "VecSrcOperand_G_A", "VecSrcOperand_G_A_AO", "VecSrcOperand_G",
  "VecSrcOpndSimple", "VMEOpndIME", "VMEOpndFBR", "SrcStateOperand",
  "DstStateOperand", "RawOperand", "RawOperandNonNull",
  "RawOperandOffsetSuffix", "RawOperandArray", "DstAddrOperand",
  "DstGeneralOperand", "DstIndirectOperand", "SrcAddrOfOperand",
  "AddrOfVar", "SrcAddrOperand", "SrcGeneralOperand", "SrcImmOperand",
  "FloatLit", "DoubleFloatLit", "SrcIndirectOperand", "DstRegion",
  "SrcRegionDirect", "SrcRegionIndirect", "IndirectVarAccess",
  "TwoDimOffset", "PredVar", "AddrVarAccess", "AddrVarAccessWithWidth",
  "SIMDMode", "ElemNum", "ExecSize", "ExecSizeInt", "Var", "VarNonNull",
  "IntExp", "IntExpCond", "IntExpAND", "IntExpXOR", "IntExpOR",
  "IntExpCmp", "IntExpRel", "IntExpNRA", "IntExpShift", "IntExpAdd",
  "IntExpMul", "IntExpUnr", "IntExpPrim", "DataType",
  "DataTypeIntOrVector", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1064)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-448)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
       4, -1064,   107,    31,   101, -1064, -1064,   -47,     4, -1064,
     137,  3170,   -14,   156,    60,   163,    60,   176,   190,    60,
     199,   238,   912,   912,   243, -1064, -1064,   238,   276,    54,
     217,   291,   290, -1064, -1064, -1064,   294,   299,   340,    45,
     343,    60,   238,   238,   238,   313,   234, -1064,   834,   306,
     322, -1064, -1064,   327,   328,   341,   342,   331, -1064,    38,
     401,     4, -1064, -1064,  2836, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064, -1064, -1064, -1064,  3244, -1064,   410,
   -1064, -1064, -1064, -1064, -1064,   422,   422, -1064,   371,   -25,
     235, -1064, -1064, -1064, -1064,    45,   568,   461,   568,   568,
   -1064, -1064, -1064, -1064, -1064,   118,   278,   -11, -1064,   -21,
     912, -1064, -1064, -1064, -1064, -1064, -1064,   387,   383, -1064,
       8, -1064, -1064, -1064,    45,    45, -1064,   238,   238,   238,
     912, -1064,   238,   383,   273,   238,   402,   363,   298,    45,
     235,   912,    45,   -21,   912,    45,    45, -1064, -1064,    45,
   -1064, -1064, -1064, -1064, -1064,   238,   238, -1064, -1064,    45,
   -1064, -1064,   285, -1064,   238,  2214, -1064, -1064,  3008,   238,
     238,   290,   290,   290,   290,   401,   401,   401,   401,   401,
     401,   401,   401,   401,   401,   401,   401,   401,   401,   238,
     238,   399,   378,   379,   477,   388,   423,   389,   483,   484,
     238,   238,   -12,   238,   401,   462,   462,   462,   396,   238,
     238,   428,    81,   304,   103,   126,   305,   129,   167,   307,
     450,   480,   481,   486,   487,   568,    59,   488,   171, -1064,
     446,   443,   448,   235, -1064,   452,    28,   454,   568, -1064,
   -1064,   456, -1064,    32,   444,   449, -1064,   135,    36, -1064,
     189,   184, -1064,   185, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064,   432, -1064,   387,   383,   912,   568,
   -1064,   254,   568,   467, -1064, -1064, -1064,   355, -1064,   441,
   -1064, -1064,   474,   -21,   912,   912,   235,    45,    45, -1064,
     217,   364,    45,    45,   475,   235,   235,   482,   235, -1064,
   -1064, -1064,   472,    66,   485,    45,   912, -1064,    94,   912,
      14,    14,    45,   358,    45, -1064, -1064,     4, -1064,   375,
     376,   290,   290,   290,   290,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   238,   238,   238,   238,   -21,
     -21,   380,   238,   238,   489,   238,   385,   238,   494,   494,
      60, -1064,   238,   912,   463,   238, -1064,   523,   468,   471,
   -1064,   238,   392,    60,   400,   394,   394,   394,   394,   394,
     394,   394,   394,   394,   394,   394,   394,   259,   541,   568,
     568,   568,   568, -1064,   531,   568,   577, -1064, -1064, -1064,
   -1064, -1064,   424,   426,   235,   -19, -1064, -1064,   568,   568,
   -1064,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   539,
     254,   467,   912,   274,   128, -1064, -1064, -1064, -1064, -1064,
   -1064,   536,   568, -1064, -1064,   542,    45, -1064,   984, -1064,
   -1064,   548, -1064, -1064,   551,   568,   912,   912,    66,   235,
     235, -1064,   912,  1041,    45,   547,   259,    45,   442,   235,
     235,   912,   235,   568,   254, -1064,   472,    -6, -1064,   553,
   -1064, -1064,   555,   568, -1064,    45,   235, -1064,   235,   912,
   -1064,   834,   554,   447,   455,   290,   290,   290,   290,   -21,
     -21,   -21,   -21,   -21,   -21,   -21,   -21,   -21,   -21,   -21,
     -21,   -21,   -21,   -21,    45,   552,   912,   912,   457,   238,
      45,   238,    45,   458,   238,   238, -1064,   912,   466,   469,
     -21, -1064,   592,   238,   238,    45,   470, -1064,   238,   445,
     238,   238,   238,   238,   259,   238,   238,   238,   238,   188,
     238,   238,   448,   188, -1064, -1064,   452,   568,   577,   577,
     606,   606,   561, -1064, -1064,   578, -1064,    45,   568, -1064,
     585,   589,   444,    33,   449, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064,   184,   184,   289,   289,   289, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064,   479,   568,   568,   568,   586, -1064,
   -1064, -1064, -1064, -1064, -1064,   568,   568,   595,   912,   912,
   -1064, -1064,   235,   192,   912,   912,   912, -1064,   235,   235,
     912,   596,   235, -1064,   593,   235,   604, -1064, -1064,    -6,
      -6,   600,   568,   568,   116,   597,   235, -1064,   912, -1064,
   -1064,   491,   492,   290,   290,   238,   238,   912,   912,    45,
     912,    45,   912,   912,   912,   912,   912,   912,   912,   912,
     912,   912,   912,   912,   912,   493,   235,   235, -1064,   235,
     235,    45,   912, -1064,    45,    45,   496,   497,   498,    50,
      50,   150, -1064,   569,   912,   912, -1064,   235,    45, -1064,
     259,   259,   259,   259,   473,   188,   283,   188,   283,   490,
     611,   613,   615,   619,   259,   259,   259,   621,   663, -1064,
   -1064,   594,   577,   577,   610, -1064,   245, -1064, -1064,   383,
     620, -1064, -1064,   568,   628,   623,   624,   632,   142,   649,
   -1064, -1064, -1064,   912,   235,   235,   235,   235,   912, -1064,
     235,   912, -1064, -1064, -1064, -1064, -1064,   644,   186, -1064,
     -10, -1064,   912,   834,   834,   238,   238,   834,   834,   912,
   -1064, -1064,   912,    45,   912,   912,   912,   912,   912, -1064,
   -1064,   912, -1064,   912,   912,   912,   912,   238,   235,   235,
     235,   235,   912,   235,   235,   235,   534, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064, -1064, -1064,   551,   238,    14,    14,
    1056,   235,   235,   283,   198,   188,   283,   490,   526, -1064,
   -1064, -1064, -1064,   259,   651, -1064,   259,   652, -1064,   259,
     653,   655,   259,   178,   178,   178,   178, -1064,   283,   188,
     -37,    41,   698, -1064, -1064, -1064, -1064,   546, -1064,   561,
   -1064, -1064, -1064, -1064,   568, -1064, -1064,   568,   235, -1064,
     235,   235,   235,   912,   235,   654, -1064,   656,   912,   235,
     235,   834,   834,   834,   834,   912, -1064, -1064,   912,   912,
   -1064, -1064, -1064, -1064, -1064,   912, -1064, -1064,   235, -1064,
   -1064,   235,   235,   235,   235,   235,   235, -1064,   912,   235,
      14, -1064, -1064,   235,   235, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064,   -10, -1064,   -37, -1064,   -10,    45, -1064,
     204, -1064, -1064,   212, -1064,   216,   224,   657,   293,   259,
     259,   259,   667, -1064,   452, -1064, -1064, -1064, -1064,   659,
     577, -1064, -1064, -1064,   671,   673, -1064, -1064, -1064,   235,
     912,   235, -1064, -1064,   912,   235,   235,   834,   834,   235,
     235, -1064, -1064,   912, -1064,   235,   235,   235,   235, -1064,
     235,   235,    14,   235,   235,   235, -1064,   -37,   658,   665,
     674,   297,   -37,    71, -1064,   568,   568,   562, -1064,   568,
   -1064,   568,   568,   568,   568,   670,   259, -1064,   259, -1064,
      42, -1064, -1064, -1064, -1064,   235, -1064,   912, -1064, -1064,
     235,   235,   235,   235, -1064, -1064, -1064,   235, -1064,   235,
     235,    14, -1064,   235, -1064,   293, -1064,   -37,   558,   568,
     568,   293,   178,   677,   678,   679, -1064,   684,   685,   680,
     289,   184,    45, -1064, -1064, -1064,   682, -1064,   912,   235,
     235,   235,   235, -1064, -1064,   235,   235,   235, -1064,   691,
     688, -1064,   184,   184,    47,   689,   568, -1064,   568, -1064,
   -1064, -1064,   293,   568,   650,   235,   235, -1064, -1064,   235,
     235, -1064,   235,   580,   -37,   178,   178,   690,   699,   701,
     705,   912, -1064, -1064,   235, -1064, -1064,   697,   706,   708,
     568, -1064, -1064, -1064,   664, -1064,   235,   -37,   588,   178,
     710,   912, -1064, -1064,   709,   717,   235,   178, -1064, -1064,
     711,   293,   568,   713,   721,    45, -1064,   293,   726, -1064
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       8,     7,     0,     9,     0,     1,     6,     0,     8,     3,
       0,   322,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   324,    23,   124,     0,   334,     0,
     320,     0,     0,   165,   166,   167,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   312,     0,   315,
     317,   319,   314,     0,     0,     0,     0,     0,   152,     0,
     328,     8,     5,    19,     0,    11,    12,    10,    35,    30,
      31,    32,    33,    34,    14,    13,    16,    15,    17,    18,
      72,    74,    75,    76,    77,    78,    79,   117,   118,   119,
     121,    80,    81,   102,    99,   100,   101,    98,   123,    97,
      82,    83,    85,    86,    88,    87,    89,    91,    92,    94,
      93,   107,   108,   109,   110,   111,   112,   113,    96,    95,
      84,    73,   120,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   122,   283,   284,   282,    90,
     103,   104,   105,   114,   115,   106,   116,     0,    29,     0,
      25,    26,    55,    36,    28,    48,    48,    27,    53,     0,
       0,   331,   330,   332,   333,     0,     0,     0,     0,     0,
     412,   411,   413,   385,   388,   447,   448,     0,   452,     0,
       0,   344,   356,   346,   381,   383,   345,     0,     0,   410,
       0,   446,   170,   325,     0,     0,   335,     0,     0,     0,
       0,   321,     0,     0,     0,     0,   404,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   302,   303,     0,
     313,   347,   348,   316,   318,     0,     0,   306,   307,     0,
     236,   237,     0,   329,     0,   322,     2,    22,   322,     0,
       0,     0,     0,     0,     0,   328,   328,   328,   328,   328,
     328,   328,   328,   328,   328,   328,   328,   328,   328,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   328,   187,   187,   187,   195,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    70,    45,    54,   409,
       0,     0,     0,     0,   362,     0,     0,     0,     0,   447,
     448,     0,   414,   416,   418,   420,   422,   425,   430,   431,
     435,   438,   442,   448,   382,   384,   443,   444,   445,   389,
     386,   390,   387,   380,     0,   450,     0,     0,   169,     0,
     395,     0,     0,     0,   458,   459,   379,   326,   401,     0,
     336,   369,     0,     0,     0,     0,     0,     0,     0,   406,
     320,     0,     0,     0,     0,     0,     0,     0,     0,   301,
     338,   339,     0,     0,     0,     0,     0,   337,     0,     0,
       0,     0,     0,     0,     0,     4,    24,     8,    20,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   210,     0,     0,     0,   173,   173,
       0,   296,     0,     0,     0,     0,   188,   181,     0,     0,
     196,     0,     0,     0,     0,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   238,   238,     0,     0,     0,
       0,     0,     0,    49,     0,     0,    70,    47,    44,    51,
      52,   407,     0,     0,     0,     0,   364,   399,     0,     0,
     449,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   430,   454,   455,   456,   457,   391,
     453,     0,     0,   377,   327,     0,     0,   354,     0,   352,
     355,   373,   353,   376,     0,     0,     0,     0,   401,     0,
       0,   205,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   371,     0,   291,   154,     0,
     155,   153,     0,     0,   145,     0,     0,   178,     0,     0,
     235,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   294,     0,     0,     0,
       0,   182,   183,     0,     0,     0,     0,   295,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   411,     0,   278,   279,   410,     0,    70,    70,
      41,    41,     0,    50,    46,     0,   363,     0,     0,   365,
       0,     0,   417,     0,   419,   421,   423,   424,   426,   427,
     428,   429,   436,   437,   432,   433,   434,   440,   441,   439,
     451,   392,   378,   168,     0,     0,   397,     0,     0,   323,
     375,   144,   349,   351,   350,     0,     0,     0,     0,     0,
     203,   204,     0,   160,     0,     0,     0,   405,     0,     0,
       0,     0,     0,   200,     0,     0,     0,   372,   370,   291,
     291,     0,     0,     0,     0,     0,     0,   190,     0,   142,
      21,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,     0,
       0,     0,     0,   174,     0,     0,     0,     0,     0,     0,
       0,     0,   184,     0,     0,     0,   191,     0,     0,   239,
       0,     0,     0,     0,     0,     0,   259,     0,   259,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    56,    39,
      38,     0,    70,    70,    67,    69,     0,   408,   139,     0,
       0,   398,   402,     0,     0,     0,     0,     0,     0,     0,
     157,   156,   202,     0,     0,     0,     0,     0,     0,   358,
       0,     0,   201,   393,   292,   293,   297,     0,     0,   361,
       0,   189,     0,     0,     0,     0,     0,     0,     0,     0,
     129,   130,     0,     0,     0,     0,     0,     0,     0,   143,
     131,     0,   133,     0,     0,     0,   135,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   299,   298,   150,
     340,   342,   341,   343,   149,   151,   401,     0,     0,     0,
     194,     0,     0,   259,     0,     0,   259,     0,     0,   289,
     285,   260,   261,     0,     0,   262,     0,     0,   242,     0,
       0,     0,     0,     0,     0,     0,     0,   286,   259,     0,
       0,     0,    62,    57,    42,    40,    43,     0,    71,     0,
     357,   366,   415,   396,     0,   400,   374,     0,     0,   159,
       0,     0,     0,     0,     0,     0,   360,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   125,   126,     0,     0,
     146,   147,   148,   132,   134,     0,   137,   138,     0,   208,
     209,     0,     0,     0,     0,     0,     0,   300,     0,     0,
       0,   192,   193,     0,     0,   224,   275,   276,   231,   225,
     226,   277,   227,   257,   232,     0,   228,   257,     0,   229,
       0,   270,   269,   272,   271,     0,     0,     0,   254,     0,
     262,     0,     0,   280,   281,    61,    58,    59,    60,     0,
      70,    66,    65,    68,     0,     0,   158,   161,   177,     0,
       0,     0,   359,   179,     0,     0,     0,     0,     0,     0,
       0,   140,   127,     0,   136,     0,     0,     0,     0,   163,
       0,     0,     0,     0,     0,     0,   141,     0,     0,   249,
       0,   246,     0,     0,   267,     0,     0,     0,   263,     0,
     265,     0,     0,     0,     0,     0,     0,   290,     0,   234,
       0,    37,   394,   403,   176,     0,   199,     0,   304,   305,
       0,     0,     0,     0,   128,   206,   207,     0,   164,     0,
       0,     0,   367,     0,   197,   254,   258,     0,     0,     0,
       0,   254,     0,     0,     0,     0,   273,     0,     0,     0,
     255,   256,     0,   230,   233,    64,     0,   175,     0,     0,
       0,     0,     0,   162,   171,     0,     0,   185,   367,     0,
     250,   253,   247,   248,     0,     0,     0,   268,     0,   264,
     266,   287,   254,     0,     0,     0,     0,   310,   311,     0,
       0,   368,   186,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   308,   309,     0,   367,   240,   251,     0,     0,
       0,   274,   288,    63,     0,   172,   180,     0,     0,     0,
       0,     0,   252,   241,     0,     0,     0,     0,   245,   198,
       0,   254,     0,     0,     0,     0,   244,   254,     0,   243
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1064, -1064, -1064,   549,   -56,    -5,   550, -1064, -1064,   232,
      10, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
     165, -1064, -1064, -1064,   633,   495, -1064, -1064, -1064, -1064,
   -1064,  -108, -1064,  -432, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064, -1064, -1064,   374, -1064, -1064,  -356,
   -1064, -1064, -1064, -1064, -1064,   104, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064,   516,  -723,   -72,   -71, -1036, -1064,  -812, -1003,  -172,
    -730,  -578,  -846,  -873,  -874,  -682,   -84,  -445,  -876, -1064,
   -1064, -1064,    44,    37, -1064,  -306, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064,   459, -1064, -1064, -1064,   602,     9,
   -1064,   218,   431,  -114,    67, -1064,   -22,  -535, -1064, -1064,
   -1064,    17, -1064, -1064, -1064,   434, -1064,   964,  -872, -1064,
   -1063, -1064,  -196, -1064,  -315, -1064,   512, -1064,    23,   661,
     662, -1064,  -340,  -307,   502,  -152,  -188,  -199, -1064,  -186,
   -1064,  -221,  2209,   354,    16,   522,  1386,    34,   346,   350,
     351,   359,   -82,  -335, -1064,  -477,  -471,  1663,  -764,  -460,
     642
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     8,    61,     3,     4,    62,    63,    64,   388,
     152,    65,    66,     9,    67,    68,    69,    70,    71,    72,
     772,    73,    74,    75,   296,   456,    76,    77,   892,   893,
     990,   775,   776,   457,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   674,   102,
     103,   104,   105,   106,   107,   108,   584,   109,   110,   546,
     111,   592,   743,   112,   113,   427,   114,   115,   860,   116,
     431,   117,   118,   119,   120,   121,   579,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     232,   600,   878,   879,   882,  1029,  1030,   876,  1045,  1027,
     874,   875,   970,   971,   972,   863,   867,   864,  1031,   135,
     136,   137,   764,   755,   138,   691,   139,   140,   141,   142,
     143,   144,   145,   146,   202,   147,   194,   505,   234,   179,
     197,   349,   375,   369,   849,   850,   851,   220,   661,   507,
     508,   181,   778,   209,   212,   538,   376,   614,   304,   466,
    1107,   350,   370,   371,   852,   511,   853,   182,   183,   184,
     185,   186,   535,   340,   341,   187,   343,   347,   306,   513,
     362,   205,   160,   300,   188,   189,   974,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   190,   191,   499,
     500
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     180,   192,   613,    11,   494,   235,   644,   645,   646,   351,
     642,   643,   978,   977,   982,   358,   699,   379,   983,   377,
     391,   392,   393,   394,   624,   548,   154,   336,   880,   157,
     651,   763,   534,   873,   510,   767,   503,   165,   975,   976,
     628,  1110,   985,  1095,   986,  1132,   917,   159,   334,   166,
     170,   213,   172,   958,   344,   210,   236,   219,   689,   238,
     345,   372,   170,   171,   172,   221,   170,   171,   172,   865,
     866,   222,  1109,   545,   687,   454,   335,   981,  1114,   455,
     422,   690,  1156,   888,   889,   467,   161,   162,   163,   164,
     477,   478,   468,   983,  1033,     1,   198,   199,  1147,   783,
     166,   170,   171,   172,  1133,   471,   471,     5,   165,   166,
     472,  1135,   308,   159,     7,   479,   480,   168,   169,  1139,
     533,   167,     6,   506,    10,   342,   168,   169,   987,   170,
     171,   172,   170,   171,   172,  1082,   880,   170,   171,   172,
     955,  1083,   638,   639,   640,   641,   299,   150,   533,   491,
     151,  1075,   629,   543,   517,   983,  1081,   148,   338,   754,
     983,   309,   310,   177,   178,   979,   329,   330,  1173,  1089,
     555,   556,   557,   558,  1178,   301,   809,   763,   356,   877,
     657,   307,   477,   656,   652,   536,   769,   770,   377,   367,
     536,   962,   374,   663,   964,   337,   688,   966,   686,  1028,
      12,   372,   789,  1028,   533,   983,   657,   479,   480,   666,
     348,   352,   309,   310,   177,   178,   475,   476,  1122,   173,
     174,   175,   176,   177,   178,   365,   230,   231,   368,   373,
     166,   378,   348,   331,   332,   337,  1115,   166,  -447,   516,
     329,   330,   308,   149,  -447,   382,   916,   168,   169,   308,
     657,   486,   487,   153,   168,   169,   488,   372,   372,   481,
     482,   459,   983,   155,  1034,   170,   171,   172,  1035,   435,
     436,  1036,   483,   484,   485,  1037,  1038,   156,   919,   920,
    1039,  1162,   923,   924,  1040,   983,   158,   877,  1041,  1148,
    1149,   438,   439,  1171,  1170,   573,   574,   159,  1047,  1174,
     344,  1177,   495,   496,   497,   498,   345,   898,   868,   899,
     980,   877,   201,  1164,   440,   441,   492,   443,   444,   754,
     193,   639,   170,   302,   172,   951,   331,   332,   333,   196,
     536,   235,   519,   520,   703,   704,   705,   706,   654,   655,
     895,   896,   309,   310,   177,   178,   170,   612,   172,   309,
     310,   177,   178,   204,   540,   445,   446,   544,   219,   481,
     482,   709,   711,  1043,  1044,   514,   509,  1079,  1080,   518,
     760,   761,   762,   522,   523,   724,   956,   957,   526,   527,
     428,   429,   552,   804,   805,   203,  1007,  1008,  1009,  1010,
     206,   539,   542,   636,   637,   207,   547,   547,   549,   208,
     373,   588,   211,   217,   351,   218,   223,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   224,   225,   226,   373,   373,   229,   227,   228,
     586,   290,   291,   292,   293,   294,   233,   868,   372,   295,
     298,   339,   342,   597,   359,   707,   708,   710,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     363,   361,   411,   615,   871,   760,   761,   762,   872,   364,
     653,   383,  1060,  1061,   412,   413,   740,   161,   162,   163,
     164,   414,   815,   816,   415,   417,   416,   418,   419,   430,
     426,   434,   437,   442,   668,   669,   447,   448,   449,   450,
     672,   675,   949,   950,   451,   452,   461,   462,   455,   684,
     821,   463,   823,   469,   506,   465,   470,   219,   473,   489,
     166,   502,   660,   504,   474,   662,   533,   698,   170,   171,
     172,   664,   308,   515,  1046,   525,  1048,   168,   169,   528,
     676,   855,   679,   680,   537,   550,   531,   553,   554,   591,
     589,   575,   578,   536,   726,   727,   581,   583,  1051,   617,
     219,   695,   992,   596,   593,   736,  1090,   594,   221,   994,
     599,   598,   995,  1091,   222,   373,   518,   518,   373,   373,
     373,   373,   373,   373,   373,   373,   373,   373,   373,   373,
     348,   900,   622,   454,  1024,   299,   730,   626,   732,   650,
     657,  1093,   659,  1094,   665,   166,   741,   677,  1112,  1113,
     666,   746,   692,   681,   693,   725,   386,   308,   701,   742,
     615,   749,   168,   169,   927,   771,   702,   166,   728,   733,
     173,   174,   175,   323,   177,   178,   991,   737,   777,   308,
     738,   747,   781,   779,   168,   169,   790,   791,   774,   782,
     784,   655,   793,   794,   795,   789,   799,   801,   798,   803,
     806,   810,   813,   814,   837,   857,  1071,   846,   847,   848,
     883,   881,   884,   869,   885,   886,   812,   890,   891,   897,
     901,   894,   305,   903,   905,   819,   820,   904,   822,   906,
     824,   825,   826,   827,   828,   829,   830,   831,   832,   833,
     834,   835,   836,   907,   916,   947,   961,   963,   965,   967,
     843,   968,   989,  1050,  1002,  1106,  1003,   309,   310,   177,
     178,  1042,   858,   859,  1049,   348,  1052,   348,  1053,  1077,
    1076,  1078,   305,  1086,  1092,  1111,  1116,  1121,  1117,   309,
     310,   177,   178,  1118,  1119,  1120,  1123,   842,  1133,  1141,
     844,   845,  1134,  1136,  1150,   514,   856,  1146,  1152,  1151,
    1153,  1157,  1161,  1158,   862,  1163,   615,   615,   615,   615,
    1165,   908,  1159,  1167,  1168,  1172,   913,  1175,  1176,   915,
     615,   615,   615,  1179,   700,   385,   773,   387,  1140,   297,
     918,   993,   458,   585,   959,  1032,   960,   925,   969,   870,
     926,   887,   928,   929,   930,   931,   932,   854,   739,   933,
     541,   934,   935,   936,   937,   551,   625,   902,   633,   524,
     943,   632,   219,   219,   634,   305,   219,   219,   324,   325,
     221,   221,   346,   635,   221,   221,   222,   222,   490,   348,
     222,   222,     0,     0,     0,     0,     0,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   512,     0,     0,     0,     0,     0,     0,     0,   219,
     161,   162,   163,   164,   547,   547,   425,   221,   305,     0,
       0,     0,     0,   222,     0,     0,     0,   305,   305,   615,
     305,  1000,   615,   166,     0,   615,  1004,     0,   615,   973,
     973,   973,   973,  1011,     0,   167,  1012,  1013,     0,     0,
     168,   169,     0,  1014,     0,     0,     0,     0,     0,     0,
       0,   170,   171,   172,     0,     0,  1022,     0,     0,     0,
     219,   219,   219,   219,     0,     0,     0,     0,   221,   221,
     221,   221,     0,     0,   222,   222,   222,   222,   161,   162,
     163,   164,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,     0,     0,     0,   547,     0,     0,   616,
     165,   166,     0,     0,     0,     0,     0,     0,  1055,     0,
       0,     0,  1057,   167,   973,     0,   305,     0,   168,   169,
       0,  1064,     0,     0,     0,   615,   615,   615,     0,   170,
     171,   172,     0,   173,   174,   175,   176,   177,   178,     0,
       0,     0,     0,     0,     0,     0,   219,   219,     0,     0,
     161,   162,   163,   164,   221,   221,     0,     0,     0,     0,
     222,   222,     0,     0,     0,  1098,     0,     0,   547,     0,
       0,   305,   305,   166,     0,     0,     0,     0,   616,     0,
       0,   305,   305,     0,   305,   167,     0,   506,     0,     0,
     168,   169,   615,     0,   615,     0,  1096,     0,   305,     0,
     305,   170,   171,   172,     0,     0,  1124,   161,   162,   163,
     164,   173,   174,   175,   176,   177,   178,   547,     0,     0,
       0,     0,   161,   162,   163,   164,     0,     0,   973,   165,
     166,     0,     0,     0,     0,     0,     0,     0,   973,     0,
       0,     0,   167,     0,     0,   166,     0,   168,   169,  1154,
       0,     0,     0,     0,   303,     0,   616,   167,   170,   171,
     172,     0,   168,   169,     0,     0,     0,     0,     0,  1166,
       0,     0,     0,   170,   612,   172,     0,     0,     0,     0,
       0,   973,   973,   173,   174,   175,   176,   177,   178,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   366,   973,     0,     0,     0,     0,
       0,     0,     0,   973,     0,     0,     0,     0,     0,     0,
       0,   973,     0,     0,   305,     0,     0,     0,     0,     0,
     305,   305,     0,     0,   305,     0,     0,   305,     0,     0,
     173,   174,   673,   176,   177,   178,     0,     0,   305,     0,
       0,     0,     0,     0,     0,   173,   174,   175,   176,   177,
     178,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   305,   305,
       0,   305,   305,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   464,     0,   305,
       0,     0,   616,   616,   616,   616,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   616,   616,   616,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   305,   305,   305,   305,
     521,     0,   305,     0,     0,     0,     0,     0,     0,   529,
     530,     0,   532,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     305,   305,   305,   305,     0,   305,   305,   305,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   616,   305,   305,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   616,     0,     0,   616,     0,
       0,   616,     0,     0,   616,     0,     0,     0,     0,     0,
       0,     0,   984,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   627,     0,
     305,     0,   305,   305,   305,     0,   305,     0,     0,     0,
       0,   305,   305,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     305,     0,     0,   305,   305,   305,   305,   305,   305,     0,
       0,   305,     0,     0,     0,   305,   305,     0,     0,     0,
       0,     0,     0,   670,   671,     0,     0,   984,     0,     0,
     678,     0,     0,   682,   683,     0,   685,     0,     0,     0,
       0,   616,   616,   616,     0,     0,     0,     0,     0,     0,
     696,     0,   697,     0,     0,     0,     0,     0,     0,     0,
       0,   305,     0,   305,     0,     0,     0,   305,   305,     0,
       0,   305,   305,     0,     0,     0,     0,   305,   305,   305,
     305,     0,   305,   305,     0,   305,   305,   305,     0,   984,
       0,     0,   311,     0,   984,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   616,     0,
     616,     0,     0,     0,     0,     0,     0,   305,     0,     0,
       0,     0,   305,   305,   305,   305,     0,     0,     0,   305,
       0,   305,   305,     0,     0,   305,     0,     0,     0,   984,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   305,   305,   305,   305,     0,     0,   305,   305,   305,
       0,     0,     0,     0,     0,     0,   792,     0,     0,     0,
       0,     0,   796,   797,     0,     0,   800,   305,   305,   802,
       0,   305,   305,     0,   305,     0,   984,     0,     0,     0,
     811,     0,     0,     0,     0,     0,   305,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   305,   984,
       0,   453,     0,     0,   460,     0,     0,     0,   305,     0,
     838,   839,     0,   840,   841,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   861,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   493,     0,     0,   501,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   909,   910,
     911,   912,     0,     0,   914,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   939,   940,   941,   942,     0,   944,   945,   946,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   952,   953,   954,     0,     0,   322,
     326,   327,   328,     0,     0,   618,   619,   620,   621,     0,
       0,   623,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   630,   631,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   996,     0,   997,   998,   999,     0,  1001,     0,
       0,     0,     0,  1005,  1006,     0,     0,     0,   658,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   667,  1015,     0,     0,  1016,  1017,  1018,  1019,  1020,
    1021,     0,     0,  1023,     0,     0,     0,  1025,  1026,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   694,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   322,     0,
       0,   322,     0,  1054,     0,  1056,     0,     0,     0,  1058,
    1059,   326,     0,  1062,  1063,     0,     0,     0,     0,  1065,
    1066,  1067,  1068,     0,  1069,  1070,     0,  1072,  1073,  1074,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   322,   768,     0,   322,     0,     0,     0,     0,
       0,     0,     0,     0,   780,     0,     0,     0,     0,  1097,
       0,     0,     0,     0,  1099,  1100,  1101,  1102,     0,     0,
       0,  1103,     0,  1104,  1105,     0,     0,  1108,     0,     0,
       0,   785,     0,   786,     0,     0,     0,     0,     0,     0,
       0,   787,   788,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1125,  1126,  1127,  1128,     0,     0,  1129,
    1130,  1131,     0,     0,     0,     0,     0,     0,   807,   808,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1142,
    1143,     0,     0,  1144,  1145,     0,  1131,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1155,     0,
       0,     0,   322,   322,   322,   322,     0,     0,   322,     0,
    1131,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1169,   322,   322,     0,   322,   322,   322,   322,   322,   322,
     322,   322,   322,   322,   322,   322,   322,   322,   322,   647,
     648,   649,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   322,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   322,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   322,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   322,     0,     0,     0,
       0,     0,     0,     0,    -9,     0,     0,     0,     0,    13,
      14,    15,    16,    17,    18,    19,    20,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   195,     0,   200,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   214,   215,   216,     0,    21,     0,     0,    22,    23,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    24,     0,    25,    -9,   988,     0,     0,
     322,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   322,     0,     0,     0,     0,     0,     0,     0,     0,
      26,     0,     0,     0,     0,     6,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    27,     0,     0,   322,   322,
     322,     0,     0,     0,     0,     0,     0,     0,   322,   322,
       0,    28,    29,     0,     0,     0,     0,    30,    31,    32,
       0,     0,     0,    33,    34,    35,     0,     0,    36,    37,
      38,    39,    40,     0,     0,   322,   322,    41,    42,    43,
      44,     0,    45,    46,    47,    48,    49,    50,    51,    52,
       0,     0,     0,    53,    54,     0,     0,    55,    56,    57,
      58,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   353,   354,   355,     0,
       0,   357,    59,    60,   360,     0,     0,     0,     0,     0,
       0,  1084,  1085,     0,     0,  1087,     0,  1088,     0,     0,
       0,     0,     0,     0,   380,   381,     0,     0,     0,     0,
       0,     0,     0,   384,     0,     0,   322,     0,   389,   390,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   409,   410,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   420,
     421,   423,   424,     0,     0,     0,     0,     0,   432,   433,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1138,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   322,   322,   322,   322,
       0,     0,     0,     0,   322,     0,     0,     0,     0,     0,
     322,     0,     0,     0,     0,     0,     0,   322,     0,     0,
     322,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,     0,     0,
       0,   576,   577,     0,   580,     0,   582,     0,     0,     0,
       0,   587,     0,     0,   590,     0,     0,     0,     0,     0,
     595,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   322,   322,
       0,     0,   322,     0,   322,   322,   322,   322,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   322,   322,     0,   322,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1137,
       0,   322,     0,     0,     0,     0,   322,     0,   729,     0,
     731,     0,     0,   734,   735,     0,     0,     0,   322,   322,
       0,     0,   744,   745,     0,     0,     0,   748,     0,   750,
     751,   752,   753,  1160,   756,   757,   758,   759,     0,   765,
     766,     0,   322,     0,     0,     0,     0,     0,     0,     0,
     322,     0,     0,     0,     0,   322,     0,   237,     0,     0,
       0,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    -8,    -8,    -8,    -8,    -8,
      -8,     0,     0,     0,     0,     0,    -8,    -8,     0,     0,
      -8,    -8,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    -8,     0,    -8,    -8,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   817,   818,     0,     0,     0,     0,
       0,     0,    -8,     0,     0,     0,     0,     1,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,     0,     0,     0,     0,     0,     0,
       0,    -8,     0,    13,    14,    15,    16,    17,    18,    19,
      20,     0,     0,     0,   921,   922,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   938,     0,     0,    21,
       0,     0,    22,    23,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   948,    24,     0,    25,
     386,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    26,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    27,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    28,    29,     0,     0,     0,
       0,    30,    31,    32,     0,     0,     0,    33,    34,    35,
       0,     0,    36,    37,    38,    39,    40,     0,     0,     0,
       0,    41,    42,    43,    44,     0,    45,    46,    47,    48,
      49,    50,    51,    52,     0,     0,     0,    53,    54,     0,
       0,    55,    56,    57,    58,    13,    14,    15,    16,    17,
      18,    19,    20,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    59,    60,     0,     0,
       0,    21,     0,     0,    22,    23,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    24,
       0,    25,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    26,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    27,     0,   239,   240,   241,   242,   243,   244,     0,
       0,     0,     0,     0,   245,     0,     0,    28,    29,     0,
       0,     0,     0,    30,    31,    32,     0,     0,     0,    33,
      34,    35,     0,     0,    36,    37,    38,    39,    40,     0,
       0,     0,     0,    41,    42,    43,    44,     0,    45,    46,
      47,    48,    49,    50,    51,    52,     0,     0,     0,    53,
      54,     0,     0,    55,    56,    57,    58,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,     0,     0,   261,   262,   263,   264,     0,    59,    60,
     265,   266,   267,     0,     0,     0,   268,   269,     0,     0,
       0,     0,     0,   270,   271,   272,   273,     0,     0,     0,
       0,   274,     0,     0,     0,     0,     0,     0,     0,     0,
     275,   276,   277,     0,     0,   278,   279,     0,     0,     0,
       0,   280,     0,     0,     0,     0,     0,     0,     0,   281,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   282,   283,   284,   285,   286,   287,
     288,   289
};

static const yytype_int16 yycheck[] =
{
      22,    23,   447,     8,   339,    61,   483,   484,   485,   195,
     481,   482,   886,   886,   890,   203,   551,   216,   890,   215,
     241,   242,   243,   244,   456,   381,    16,   179,   758,    19,
     490,   609,   372,   756,   349,   613,   343,    58,   884,   885,
      59,  1077,     1,     1,     3,  1108,   810,    59,    59,    59,
      87,    41,    89,   865,    46,    39,    61,    48,    64,    64,
      52,   213,    87,    88,    89,    48,    87,    88,    89,   751,
     752,    48,  1075,    59,   534,    16,    87,   889,  1081,    20,
      92,    87,  1145,   765,   766,    57,    36,    37,    38,    39,
      54,    55,    64,   965,   968,    91,    42,    43,  1134,    66,
      59,    87,    88,    89,    57,    73,    73,     0,    58,    59,
      78,    64,    71,    59,    13,    79,    80,    76,    77,  1122,
      54,    71,    91,    73,   171,    59,    76,    77,    87,    87,
      88,    89,    87,    88,    89,    64,   866,    87,    88,    89,
     863,    70,   477,   478,   479,   480,   171,    87,    54,   337,
      90,  1027,   171,    59,   353,  1027,  1032,   171,   180,   604,
    1032,   171,   172,   173,   174,   888,    48,    49,  1171,  1042,
     391,   392,   393,   394,  1177,   159,    60,   755,   200,   757,
      64,   165,    54,    55,   491,   373,   618,   619,   384,   211,
     378,   873,   214,   508,   876,   179,   536,   879,   533,   963,
      63,   353,    60,   967,    54,  1077,    64,    79,    80,    59,
     194,   195,   171,   172,   173,   174,    81,    82,  1092,   169,
     170,   171,   172,   173,   174,   209,   188,   189,   212,   213,
      59,   215,   216,    48,    49,   219,  1082,    59,    46,   353,
      48,    49,    71,    87,    52,   229,    60,    76,    77,    71,
      64,    67,    68,    90,    76,    77,    72,   409,   410,    70,
      71,    90,  1134,    87,    60,    87,    88,    89,    64,   188,
     189,    59,    83,    84,    85,    63,    60,    87,   813,   814,
      64,  1157,   817,   818,    60,  1157,    87,   865,    64,  1135,
    1136,   188,   189,  1167,  1167,   409,   410,    59,   980,  1172,
      46,  1175,    48,    49,    50,    51,    52,    62,   753,    64,
     888,   889,    95,  1159,   188,   189,   338,   188,   189,   764,
      77,   656,    87,    88,    89,   860,    48,    49,    50,    53,
     518,   387,   354,   355,   555,   556,   557,   558,    64,    65,
     772,   773,   171,   172,   173,   174,    87,    88,    89,   171,
     172,   173,   174,    63,   376,   188,   189,   379,   349,    70,
      71,   560,   561,    70,    71,   349,   349,    70,    71,   353,
     182,   183,   184,   357,   358,   574,   178,   179,   362,   363,
     276,   277,   387,   689,   690,    94,   921,   922,   923,   924,
      96,   375,   376,   475,   476,    96,   380,   381,   382,    59,
     384,   423,    59,    90,   590,   171,   100,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   100,    96,    96,   409,   410,    96,    87,    87,
     420,    21,    22,    23,    24,    25,    35,   882,   590,    17,
      69,    54,    59,   433,   171,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
      97,    59,    63,   447,   181,   182,   183,   184,   185,   171,
     492,   186,  1007,  1008,    96,    96,   590,    36,    37,    38,
      39,     4,   703,   704,    96,    96,    63,     4,     4,    93,
      28,    63,   188,   188,   516,   517,   189,    47,    18,    18,
     522,   523,   858,   859,    18,    18,    60,    64,    20,   531,
     709,    63,   711,    59,    73,    63,    60,   508,    74,    87,
      59,    54,   506,   168,    75,   508,    54,   549,    87,    88,
      89,   508,    71,    59,   979,   171,   981,    76,    77,    64,
     524,   740,   526,   527,    59,   187,    64,   172,   172,    26,
      87,   171,    63,   741,   576,   577,   171,    63,   990,    18,
     551,   545,   897,   171,    96,   587,  1043,    96,   551,   904,
     176,   171,   907,  1044,   551,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   779,    61,    16,   950,   171,   580,   171,   582,    60,
      64,  1046,    60,  1048,    56,    59,   590,    60,  1079,  1080,
      59,   595,    59,   171,    59,    63,    62,    71,   171,    27,
     604,   176,    76,    77,   823,    19,   171,    59,   171,   171,
     169,   170,   171,   172,   173,   174,    90,   171,    60,    71,
     171,   171,    57,   627,    76,    77,   668,   669,    87,    60,
     171,    65,   674,   675,   676,    60,    60,    64,   680,    55,
      60,    64,   171,   171,   171,    96,  1022,   171,   171,   171,
      59,   181,    59,   200,    59,    56,   698,    56,    15,    69,
      60,    87,   160,    55,    60,   707,   708,    64,   710,    57,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,    54,    60,   171,   180,    56,    56,    56,
     732,    56,    14,    54,    60,  1071,    60,   171,   172,   173,
     174,    64,   744,   745,    57,   709,    55,   711,    55,    64,
      72,    57,   210,   171,    64,   177,    59,    57,    60,   171,
     172,   173,   174,    64,    60,    60,    64,   731,    57,    99,
     734,   735,    64,    64,    64,   739,   740,   177,    57,    60,
      55,    64,    98,    57,   748,   177,   750,   751,   752,   753,
      60,   793,    64,    64,    57,    64,   798,    64,    57,   801,
     764,   765,   766,    57,   552,   235,   621,   238,  1123,   156,
     812,   899,   297,   419,   866,   967,   867,   819,   882,   755,
     822,   764,   824,   825,   826,   827,   828,   740,   590,   831,
     376,   833,   834,   835,   836,   384,   462,   783,   472,   360,
     842,   471,   813,   814,   473,   303,   817,   818,   167,   167,
     813,   814,   190,   474,   817,   818,   813,   814,   336,   823,
     817,   818,    -1,    -1,    -1,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   349,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   860,
      36,    37,    38,    39,   858,   859,   274,   860,   356,    -1,
      -1,    -1,    -1,   860,    -1,    -1,    -1,   365,   366,   873,
     368,   913,   876,    59,    -1,   879,   918,    -1,   882,   883,
     884,   885,   886,   925,    -1,    71,   928,   929,    -1,    -1,
      76,    77,    -1,   935,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    88,    89,    -1,    -1,   948,    -1,    -1,    -1,
     921,   922,   923,   924,    -1,    -1,    -1,    -1,   921,   922,
     923,   924,    -1,    -1,   921,   922,   923,   924,    36,    37,
      38,    39,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,    -1,    -1,   950,    -1,    -1,   447,
      58,    59,    -1,    -1,    -1,    -1,    -1,    -1,  1000,    -1,
      -1,    -1,  1004,    71,   968,    -1,   464,    -1,    76,    77,
      -1,  1013,    -1,    -1,    -1,   979,   980,   981,    -1,    87,
      88,    89,    -1,   169,   170,   171,   172,   173,   174,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1007,  1008,    -1,    -1,
      36,    37,    38,    39,  1007,  1008,    -1,    -1,    -1,    -1,
    1007,  1008,    -1,    -1,    -1,  1057,    -1,    -1,  1022,    -1,
      -1,   519,   520,    59,    -1,    -1,    -1,    -1,   526,    -1,
      -1,   529,   530,    -1,   532,    71,    -1,    73,    -1,    -1,
      76,    77,  1046,    -1,  1048,    -1,  1050,    -1,   546,    -1,
     548,    87,    88,    89,    -1,    -1,  1098,    36,    37,    38,
      39,   169,   170,   171,   172,   173,   174,  1071,    -1,    -1,
      -1,    -1,    36,    37,    38,    39,    -1,    -1,  1082,    58,
      59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1092,    -1,
      -1,    -1,    71,    -1,    -1,    59,    -1,    76,    77,  1141,
      -1,    -1,    -1,    -1,   160,    -1,   604,    71,    87,    88,
      89,    -1,    76,    77,    -1,    -1,    -1,    -1,    -1,  1161,
      -1,    -1,    -1,    87,    88,    89,    -1,    -1,    -1,    -1,
      -1,  1135,  1136,   169,   170,   171,   172,   173,   174,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   210,  1159,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1175,    -1,    -1,   672,    -1,    -1,    -1,    -1,    -1,
     678,   679,    -1,    -1,   682,    -1,    -1,   685,    -1,    -1,
     169,   170,   171,   172,   173,   174,    -1,    -1,   696,    -1,
      -1,    -1,    -1,    -1,    -1,   169,   170,   171,   172,   173,
     174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   726,   727,
      -1,   729,   730,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   303,    -1,   747,
      -1,    -1,   750,   751,   752,   753,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   764,   765,   766,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   794,   795,   796,   797,
     356,    -1,   800,    -1,    -1,    -1,    -1,    -1,    -1,   365,
     366,    -1,   368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     838,   839,   840,   841,    -1,   843,   844,   845,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   860,   861,   862,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   873,    -1,    -1,   876,    -1,
      -1,   879,    -1,    -1,   882,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   890,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   464,    -1,
     908,    -1,   910,   911,   912,    -1,   914,    -1,    -1,    -1,
      -1,   919,   920,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     938,    -1,    -1,   941,   942,   943,   944,   945,   946,    -1,
      -1,   949,    -1,    -1,    -1,   953,   954,    -1,    -1,    -1,
      -1,    -1,    -1,   519,   520,    -1,    -1,   965,    -1,    -1,
     526,    -1,    -1,   529,   530,    -1,   532,    -1,    -1,    -1,
      -1,   979,   980,   981,    -1,    -1,    -1,    -1,    -1,    -1,
     546,    -1,   548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   999,    -1,  1001,    -1,    -1,    -1,  1005,  1006,    -1,
      -1,  1009,  1010,    -1,    -1,    -1,    -1,  1015,  1016,  1017,
    1018,    -1,  1020,  1021,    -1,  1023,  1024,  1025,    -1,  1027,
      -1,    -1,   166,    -1,  1032,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1046,    -1,
    1048,    -1,    -1,    -1,    -1,    -1,    -1,  1055,    -1,    -1,
      -1,    -1,  1060,  1061,  1062,  1063,    -1,    -1,    -1,  1067,
      -1,  1069,  1070,    -1,    -1,  1073,    -1,    -1,    -1,  1077,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1099,  1100,  1101,  1102,    -1,    -1,  1105,  1106,  1107,
      -1,    -1,    -1,    -1,    -1,    -1,   672,    -1,    -1,    -1,
      -1,    -1,   678,   679,    -1,    -1,   682,  1125,  1126,   685,
      -1,  1129,  1130,    -1,  1132,    -1,  1134,    -1,    -1,    -1,
     696,    -1,    -1,    -1,    -1,    -1,  1144,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1156,  1157,
      -1,   295,    -1,    -1,   298,    -1,    -1,    -1,  1166,    -1,
     726,   727,    -1,   729,   730,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   747,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,   342,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   794,   795,
     796,   797,    -1,    -1,   800,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   838,   839,   840,   841,    -1,   843,   844,   845,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   860,   861,   862,    -1,    -1,   166,
     167,   168,   169,    -1,    -1,   449,   450,   451,   452,    -1,
      -1,   455,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   468,   469,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   908,    -1,   910,   911,   912,    -1,   914,    -1,
      -1,    -1,    -1,   919,   920,    -1,    -1,    -1,   502,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   515,   938,    -1,    -1,   941,   942,   943,   944,   945,
     946,    -1,    -1,   949,    -1,    -1,    -1,   953,   954,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   543,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   295,    -1,
      -1,   298,    -1,   999,    -1,  1001,    -1,    -1,    -1,  1005,
    1006,   308,    -1,  1009,  1010,    -1,    -1,    -1,    -1,  1015,
    1016,  1017,  1018,    -1,  1020,  1021,    -1,  1023,  1024,  1025,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   339,   617,    -1,   342,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   628,    -1,    -1,    -1,    -1,  1055,
      -1,    -1,    -1,    -1,  1060,  1061,  1062,  1063,    -1,    -1,
      -1,  1067,    -1,  1069,  1070,    -1,    -1,  1073,    -1,    -1,
      -1,   655,    -1,   657,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   665,   666,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1099,  1100,  1101,  1102,    -1,    -1,  1105,
    1106,  1107,    -1,    -1,    -1,    -1,    -1,    -1,   692,   693,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,
    1126,    -1,    -1,  1129,  1130,    -1,  1132,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1144,    -1,
      -1,    -1,   449,   450,   451,   452,    -1,    -1,   455,    -1,
    1156,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1166,   468,   469,    -1,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   502,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   515,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   533,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   543,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     0,    -1,    -1,    -1,    -1,     5,
       6,     7,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    44,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    59,    -1,    61,    62,   891,    -1,    -1,
     617,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   628,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      86,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   101,    -1,    -1,   655,   656,
     657,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   665,   666,
      -1,   117,   118,    -1,    -1,    -1,    -1,   123,   124,   125,
      -1,    -1,    -1,   129,   130,   131,    -1,    -1,   134,   135,
     136,   137,   138,    -1,    -1,   692,   693,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,    -1,    -1,   159,   160,    -1,    -1,   163,   164,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   197,   198,   199,    -1,
      -1,   202,   198,   199,   205,    -1,    -1,    -1,    -1,    -1,
      -1,  1035,  1036,    -1,    -1,  1039,    -1,  1041,    -1,    -1,
      -1,    -1,    -1,    -1,   225,   226,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   234,    -1,    -1,   783,    -1,   239,   240,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   259,   260,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   270,
     271,   272,   273,    -1,    -1,    -1,    -1,    -1,   279,   280,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1118,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   883,   884,   885,   886,
      -1,    -1,    -1,    -1,   891,    -1,    -1,    -1,    -1,    -1,
     897,    -1,    -1,    -1,    -1,    -1,    -1,   904,    -1,    -1,
     907,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,    -1,
      -1,   412,   413,    -1,   415,    -1,   417,    -1,    -1,    -1,
      -1,   422,    -1,    -1,   425,    -1,    -1,    -1,    -1,    -1,
     431,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1035,  1036,
      -1,    -1,  1039,    -1,  1041,  1042,  1043,  1044,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1079,  1080,    -1,  1082,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1116,
      -1,  1118,    -1,    -1,    -1,    -1,  1123,    -1,   579,    -1,
     581,    -1,    -1,   584,   585,    -1,    -1,    -1,  1135,  1136,
      -1,    -1,   593,   594,    -1,    -1,    -1,   598,    -1,   600,
     601,   602,   603,  1150,   605,   606,   607,   608,    -1,   610,
     611,    -1,  1159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1167,    -1,    -1,    -1,    -1,  1172,    -1,     1,    -1,    -1,
      -1,     5,     6,     7,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    29,    30,    31,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    40,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    59,    -1,    61,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   705,   706,    -1,    -1,    -1,    -1,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,    -1,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    -1,    -1,   815,   816,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   837,    -1,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   857,    59,    -1,    61,
      62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   117,   118,    -1,    -1,    -1,
      -1,   123,   124,   125,    -1,    -1,    -1,   129,   130,   131,
      -1,    -1,   134,   135,   136,   137,   138,    -1,    -1,    -1,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,    -1,    -1,   159,   160,    -1,
      -1,   163,   164,   165,   166,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   198,   199,    -1,    -1,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    59,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   101,    -1,    29,    30,    31,    32,    33,    34,    -1,
      -1,    -1,    -1,    -1,    40,    -1,    -1,   117,   118,    -1,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,    -1,   129,
     130,   131,    -1,    -1,   134,   135,   136,   137,   138,    -1,
      -1,    -1,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,    -1,    -1,   159,
     160,    -1,    -1,   163,   164,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,    -1,    -1,   119,   120,   121,   122,    -1,   198,   199,
     126,   127,   128,    -1,    -1,    -1,   132,   133,    -1,    -1,
      -1,    -1,    -1,   139,   140,   141,   142,    -1,    -1,    -1,
      -1,   147,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     156,   157,   158,    -1,    -1,   161,   162,    -1,    -1,    -1,
      -1,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   190,   191,   192,   193,   194,   195,
     196,   197
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    91,   202,   205,   206,     0,    91,    13,   203,   214,
     171,   206,    63,     5,     6,     7,     8,     9,    10,    11,
      12,    41,    44,    45,    59,    61,    86,   101,   117,   118,
     123,   124,   125,   129,   130,   131,   134,   135,   136,   137,
     138,   143,   144,   145,   146,   148,   149,   150,   151,   152,
     153,   154,   155,   159,   160,   163,   164,   165,   166,   198,
     199,   204,   207,   208,   209,   212,   213,   215,   216,   217,
     218,   219,   220,   222,   223,   224,   227,   228,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   260,   261,   262,   263,   264,   265,   266,   268,
     269,   271,   274,   275,   277,   278,   280,   282,   283,   284,
     285,   286,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   320,   321,   322,   325,   327,
     328,   329,   330,   331,   332,   333,   334,   336,   171,    87,
      87,    90,   211,    90,   211,    87,    87,   211,    87,    59,
     383,    36,    37,    38,    39,    58,    59,    71,    76,    77,
      87,    88,    89,   169,   170,   171,   172,   173,   174,   340,
     347,   352,   368,   369,   370,   371,   372,   376,   385,   386,
     398,   399,   347,    77,   337,   383,    53,   341,    42,    43,
     383,    95,   335,    94,    63,   382,    96,    96,    59,   354,
     385,    59,   355,   211,   383,   383,   383,    90,   171,   340,
     348,   352,   369,   100,   100,    96,    96,    87,    87,    96,
     188,   189,   301,    35,   339,   205,   206,     1,   206,    29,
      30,    31,    32,    33,    34,    40,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   119,   120,   121,   122,   126,   127,   128,   132,   133,
     139,   140,   141,   142,   147,   156,   157,   158,   161,   162,
     167,   175,   190,   191,   192,   193,   194,   195,   196,   197,
      21,    22,    23,    24,    25,    17,   225,   225,    69,   171,
     384,   385,    88,   358,   359,   386,   379,   385,    71,   171,
     172,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   172,   370,   371,   398,   398,   398,    48,
      49,    48,    49,    50,    59,    87,   376,   385,   347,    54,
     374,   375,    59,   377,    46,    52,   401,   378,   385,   342,
     362,   380,   385,   383,   383,   383,   347,   383,   377,   171,
     383,    59,   381,    97,   171,   385,   358,   347,   385,   344,
     363,   364,   376,   385,   347,   343,   357,   363,   385,   378,
     383,   383,   385,   186,   383,   207,    62,   204,   210,   383,
     383,   382,   382,   382,   382,   339,   339,   339,   339,   339,
     339,   339,   339,   339,   339,   339,   339,   339,   339,   383,
     383,    63,    96,    96,     4,    96,    63,    96,     4,     4,
     383,   383,    92,   383,   383,   339,    28,   276,   276,   276,
      93,   281,   383,   383,    63,   188,   189,   188,   188,   189,
     188,   189,   188,   188,   189,   188,   189,   189,    47,    18,
      18,    18,    18,   387,    16,    20,   226,   234,   226,    90,
     387,    60,    64,    63,   358,    63,   360,    57,    64,    59,
      60,    73,    78,    74,    75,    81,    82,    54,    55,    79,
      80,    70,    71,    83,    84,    85,    67,    68,    72,    87,
     375,   377,   347,   387,   394,    48,    49,    50,    51,   400,
     401,   387,    54,   374,   168,   338,    73,   350,   351,   352,
     365,   366,   367,   380,   385,    59,   344,   378,   385,   347,
     347,   358,   385,   385,   335,   171,   385,   385,    64,   358,
     358,    64,   358,    54,   373,   373,   377,    59,   356,   385,
     347,   356,   385,    59,   347,    59,   270,   385,   270,   385,
     187,   343,   206,   172,   172,   382,   382,   382,   382,   383,
     383,   383,   383,   383,   383,   383,   383,   383,   383,   383,
     383,   383,   383,   344,   344,   171,   383,   383,    63,   287,
     383,   171,   383,    63,   267,   267,   211,   383,   347,    87,
     383,    26,   272,    96,    96,   383,   171,   211,   171,   176,
     302,   302,   302,   302,   302,   302,   302,   302,   302,   302,
     302,   302,    88,   318,   358,   385,   386,    18,   387,   387,
     387,   387,    61,   387,   234,   384,   171,   358,    59,   171,
     387,   387,   390,   389,   391,   392,   393,   393,   394,   394,
     394,   394,   397,   397,   396,   396,   396,   398,   398,   398,
      60,   400,   374,   347,    64,    65,    55,    64,   387,    60,
     385,   349,   352,   365,   369,    56,    59,   387,   347,   347,
     358,   358,   347,   171,   259,   347,   385,    60,   358,   385,
     385,   171,   358,   358,   347,   358,   394,   400,   373,    64,
      87,   326,    59,    59,   387,   385,   358,   358,   347,   348,
     210,   171,   171,   382,   382,   382,   382,   344,   344,   378,
     344,   378,   344,   344,   344,   344,   344,   344,   344,   344,
     344,   344,   344,   344,   378,    63,   347,   347,   171,   383,
     385,   383,   385,   171,   383,   383,   347,   171,   171,   342,
     344,   385,    27,   273,   383,   383,   385,   171,   383,   176,
     383,   383,   383,   383,   318,   324,   383,   383,   383,   383,
     182,   183,   184,   312,   323,   383,   383,   312,   387,   234,
     234,    19,   221,   221,    87,   232,   233,    60,   353,   385,
     387,    57,    60,    66,   171,   387,   387,   387,   387,    60,
     347,   347,   358,   347,   347,   347,   358,   358,   347,    60,
     358,    64,   358,    55,   326,   326,    60,   387,   387,    60,
      64,   358,   347,   171,   171,   382,   382,   383,   383,   347,
     347,   378,   347,   378,   347,   347,   347,   347,   347,   347,
     347,   347,   347,   347,   347,   347,   347,   171,   358,   358,
     358,   358,   385,   347,   385,   385,   171,   171,   171,   345,
     346,   347,   365,   367,   345,   378,   385,    96,   347,   347,
     279,   358,   385,   316,   318,   316,   316,   317,   318,   200,
     323,   181,   185,   303,   311,   312,   308,   312,   303,   304,
     311,   181,   305,    59,    59,    59,    56,   324,   316,   316,
      56,    15,   229,   230,    87,   234,   234,    69,    62,    64,
     377,    60,   388,    55,    64,    60,    57,    54,   347,   358,
     358,   358,   358,   347,   358,   347,    60,   399,   347,   348,
     348,   383,   383,   348,   348,   347,   347,   378,   347,   347,
     347,   347,   347,   347,   347,   347,   347,   347,   383,   358,
     358,   358,   358,   347,   358,   358,   358,   171,   383,   270,
     270,   348,   358,   358,   358,   303,   178,   179,   308,   304,
     305,   180,   316,    56,   316,    56,   316,    56,    56,   317,
     313,   314,   315,   385,   387,   313,   313,   314,   315,   303,
     312,   308,   319,   359,   386,     1,     3,    87,   387,    14,
     231,    90,   394,   232,   394,   394,   358,   358,   358,   358,
     347,   358,    60,    60,   347,   358,   358,   348,   348,   348,
     348,   347,   347,   347,   347,   358,   358,   358,   358,   358,
     358,   358,   347,   358,   270,   358,   358,   310,   399,   306,
     307,   319,   310,   315,    60,    64,    59,    63,    60,    64,
      60,    64,    64,    70,    71,   309,   318,   316,   318,    57,
      54,   234,    55,    55,   358,   347,   358,   347,   358,   358,
     348,   348,   358,   358,   347,   358,   358,   358,   358,   358,
     358,   270,   358,   358,   358,   319,    72,    64,    57,    70,
      71,   319,    64,    70,   387,   387,   171,   387,   387,   314,
     396,   397,    64,   318,   318,     1,   385,   358,   347,   358,
     358,   358,   358,   358,   358,   358,   270,   361,   358,   309,
     306,   177,   397,   397,   309,   313,    59,    60,    64,    60,
      60,    57,   315,    64,   347,   358,   358,   358,   358,   358,
     358,   358,   361,    57,    64,    64,    64,   398,   387,   309,
     394,    99,   358,   358,   358,   358,   177,   306,   313,   313,
      64,    60,    57,    55,   347,   358,   361,    64,    57,    64,
     398,    98,   319,   177,   313,    60,   347,    64,    57,   358,
     314,   315,    64,   309,   314,    64,    57,   315,   309,    57
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   201,   202,   203,   204,   204,   205,   205,   206,   206,
     207,   207,   207,   207,   207,   207,   207,   207,   207,   207,
     208,   208,   208,   209,   210,   211,   211,   212,   213,   214,
     215,   215,   215,   215,   215,   215,   216,   217,   218,   219,
     220,   221,   221,   222,   223,   223,   224,   224,   225,   225,
     226,   227,   227,   227,   227,   228,   229,   229,   230,   230,
     230,   230,   231,   231,   231,   232,   232,   232,   233,   233,
     234,   234,   235,   235,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   236,   237,   237,   237,   237,   238,
     238,   239,   240,   241,   242,   242,   243,   243,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     254,   254,   255,   256,   256,   256,   257,   257,   258,   258,
     259,   260,   261,   262,   263,   264,   264,   264,   264,   264,
     264,   265,   266,   267,   267,   268,   269,   269,   270,   270,
     271,   272,   272,   273,   273,   274,   275,   276,   276,   277,
     278,   279,   279,   279,   280,   281,   281,   282,   283,   284,
     284,   284,   285,   286,   286,   286,   286,   286,   286,   286,
     287,   287,   288,   288,   288,   288,   288,   288,   288,   288,
     288,   288,   288,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   301,   302,   302,
     303,   304,   304,   305,   305,   305,   306,   306,   306,   307,
     307,   307,   307,   308,   309,   309,   309,   310,   310,   311,
     311,   311,   311,   312,   312,   312,   312,   312,   312,   313,
     313,   314,   315,   315,   315,   316,   316,   317,   318,   318,
     319,   319,   320,   320,   320,   321,   322,   323,   323,   324,
     325,   326,   326,   326,   327,   327,   327,   327,   327,   327,
     327,   327,   328,   329,   330,   330,   331,   332,   333,   333,
     333,   333,   334,   334,   334,   334,   334,   334,   334,   334,
     335,   335,   336,   336,   337,   337,   338,   338,   339,   339,
     340,   340,   340,   340,   341,   341,   342,   343,   344,   344,
     345,   345,   346,   346,   347,   347,   347,   348,   348,   349,
     349,   349,   350,   350,   351,   351,   352,   353,   354,   355,
     356,   357,   358,   358,   359,   360,   360,   361,   361,   362,
     363,   363,   364,   365,   365,   366,   367,   368,   368,   369,
     369,   369,   369,   369,   369,   370,   370,   370,   371,   371,
     371,   372,   372,   373,   374,   375,   375,   375,   376,   376,
     377,   378,   379,   380,   381,   381,   382,   383,   383,   384,
     385,   385,   386,   386,   387,   388,   388,   389,   389,   390,
     390,   391,   391,   392,   392,   392,   393,   393,   393,   393,
     393,   394,   395,   395,   395,   395,   396,   396,   396,   397,
     397,   397,   397,   398,   398,   398,   398,   399,   399,   399,
     399,   399,   399,   400,   400,   400,   400,   400,   401,   401
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     5,     1,     3,     1,     2,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     5,     2,     1,     1,     1,     1,     2,     2,     4,
       1,     1,     1,     1,     1,     1,     2,     9,     6,     6,
       7,     0,     2,     7,     4,     3,     5,     4,     0,     2,
       2,     4,     4,     2,     3,     2,     0,     1,     2,     2,
       2,     2,     0,     6,     3,     3,     3,     1,     3,     1,
       0,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     7,     7,     8,     9,     6,
       6,     6,     7,     6,     7,     6,     8,     7,     7,     6,
       8,     8,     5,     6,     5,     4,     7,     7,     7,     6,
       6,     6,     1,     4,     4,     4,     6,     6,     8,     7,
       1,     8,    10,     8,     9,     1,     1,     1,     5,     3,
       2,    10,    13,     0,     2,    10,     9,     8,     1,     5,
      13,     0,     1,     0,     1,    10,    11,     0,     1,     6,
       5,     0,     2,     2,     6,     0,     1,     9,    16,     9,
       5,     6,     6,     5,     5,     4,     9,     9,     7,     7,
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     7,     7,     7,     7,     7,     7,
       9,     7,     7,     9,     8,     4,     1,     1,     0,     2,
       7,     9,     1,    16,    14,    10,     1,     3,     3,     1,
       3,     5,     7,     5,     0,     2,     2,     0,     2,     0,
       1,     1,     1,     4,     6,     4,     6,     4,     6,     1,
       1,     1,     1,     3,     6,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     6,     6,     6,     8,     2,
       8,     0,     2,     2,     4,     4,     3,     6,     6,     6,
       7,     3,     2,     2,     9,     9,     2,     2,    12,    12,
      11,    11,     1,     2,     1,     1,     2,     1,     2,     1,
       0,     1,     0,     5,     0,     1,     0,     1,     0,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     5,     7,
       4,     4,     1,     3,     2,     2,     4,     0,     2,     1,
       3,     2,     3,     1,     4,     2,     1,     3,     4,     2,
       2,     1,     2,     1,     2,     1,     2,     2,     1,     2,
       2,     3,     4,     3,     7,     1,     5,     3,     5,     3,
       5,     1,     4,     7,     0,     3,     2,     3,     5,     1,
       1,     1,     1,     1,     1,     5,     1,     3,     1,     3,
       1,     3,     1,     3,     3,     1,     3,     3,     3,     3,
       1,     1,     3,     3,     3,     1,     3,     3,     1,     3,
       3,     3,     1,     2,     2,     2,     1,     1,     1,     3,
       2,     4,     1,     1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (pBuilder, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, pBuilder); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (pBuilder);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, pBuilder);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, CISA_IR_Builder* pBuilder)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], pBuilder);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, pBuilder); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, CISA_IR_Builder* pBuilder)
{
  YY_USE (yyvaluep);
  YY_USE (pBuilder);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (CISA_IR_Builder* pBuilder)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (pBuilder);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* Listing: NewlinesOpt ListingHeader NewlinesOpt Statements NewlinesOpt  */
#line 669 "CISA.y"
                                                                      {
        TRACE("** Listing Complete\n");
        pBuilder->CISA_post_file_parse();
    }
#line 3130 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 22: /* Scope: ScopeStart error  */
#line 698 "CISA.y"
                       {
        PARSE_ERROR_AT((int)(yyvsp[-1].intval), "unclosed scope");
    }
#line 3138 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 23: /* ScopeStart: LBRACE  */
#line 702 "CISA.y"
           {
        pBuilder->CISA_push_decl_scope();
        (yyval.intval) = CISAlineno;
    }
#line 3147 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 24: /* ScopeEnd: RBRACE  */
#line 706 "CISA.y"
                 {pBuilder->CISA_pop_decl_scope();}
#line 3153 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 27: /* DirectiveKernel: DIRECTIVE_KERNEL IdentOrStringLit  */
#line 717 "CISA.y"
    {
        VISAKernel *cisa_kernel = NULL;
        pBuilder->AddKernel(cisa_kernel, (yyvsp[0].string));
    }
#line 3162 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 28: /* DirectiveGlobalFunction: DIRECTIVE_GLOBAL_FUNC IdentOrStringLit  */
#line 725 "CISA.y"
  {
      VISAFunction *cisa_kernel = NULL;
      pBuilder->AddFunction(cisa_kernel, (yyvsp[0].string));
  }
#line 3171 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 29: /* DirectiveVersion: DIRECTIVE_VERSION DEC_LIT DOT DEC_LIT  */
#line 733 "CISA.y"
   {
       pBuilder->CISA_IR_setVersion((unsigned char)(yyvsp[-2].intval), (unsigned char)(yyvsp[0].intval));
   }
#line 3179 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 36: /* DeclFunction: DIRECTIVE_FUNCDECL STRING_LIT  */
#line 747 "CISA.y"
    {
        // do nothing as it's informational only
    }
#line 3187 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 37: /* DeclVariable: DIRECTIVE_DECL IDENT V_TYPE_EQ_G DECL_DATA_TYPE NUM_ELTS_EQ IntExp AlignAttrOpt AliasAttrOpt GenAttrOpt  */
#line 754 "CISA.y"
    {
       ABORT_ON_FAIL(pBuilder->CISA_general_variable_decl(
           (yyvsp[-7].string), (unsigned int)(yyvsp[-3].intval), (yyvsp[-5].type), (yyvsp[-2].align), (yyvsp[-1].alias).aliasname, (yyvsp[-1].alias).offset, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
    }
#line 3197 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 38: /* DeclAddress: DIRECTIVE_DECL IDENT V_TYPE_EQ_A NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 762 "CISA.y"
   {
       ABORT_ON_FAIL(
           pBuilder->CISA_addr_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), ISA_TYPE_UW, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3207 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 39: /* DeclPredicate: DIRECTIVE_DECL IDENT V_TYPE_EQ_P NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 770 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_predicate_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3216 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 40: /* DeclSampler: DIRECTIVE_DECL IDENT V_TYPE_EQ_S NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 777 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_sampler_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), CISAlineno));
   }
#line 3224 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 41: /* VNameEqOpt: %empty  */
#line 780 "CISA.y"
                    {(yyval.string) = "";}
#line 3230 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 42: /* VNameEqOpt: V_NAME_EQ IDENT  */
#line 780 "CISA.y"
                                                 {(yyval.string) = (yyvsp[0].string);}
#line 3236 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 43: /* DeclSurface: DIRECTIVE_DECL IDENT V_TYPE_EQ_T NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 784 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_surface_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3245 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 44: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset InputSize  */
#line 792 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 3253 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 45: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset  */
#line 797 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-1].string), (short)(yyvsp[0].intval), (unsigned short)size, CISAlineno));
    }
#line 3264 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 46: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset InputSize GenAttrOpt  */
#line 809 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_implicit_input_directive(
            (yyvsp[-4].string), (yyvsp[-3].string), (short)(yyvsp[-2].intval), (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 3273 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 47: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset GenAttrOpt  */
#line 816 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-2].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)size, CISAlineno));
    }
#line 3284 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 48: /* InputOffset: %empty  */
#line 823 "CISA.y"
                    {(yyval.intval) = 0;}
#line 3290 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 49: /* InputOffset: OFFSET_EQ IntExp  */
#line 823 "CISA.y"
                                                 {(yyval.intval) = (yyvsp[0].intval);}
#line 3296 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 50: /* InputSize: SIZE_EQ IntExp  */
#line 824 "CISA.y"
                          {(yyval.intval) = (yyvsp[0].intval);}
#line 3302 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 51: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS STRING_LIT  */
#line 830 "CISA.y"
                                                  {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-2].string), (yyvsp[0].string), CISAlineno));
    }
#line 3310 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 52: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS IntExp  */
#line 834 "CISA.y"
                                              {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directiveNum((yyvsp[-2].string), (uint32_t)(yyvsp[0].intval), CISAlineno));
    }
#line 3318 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 53: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT  */
#line 838 "CISA.y"
                                {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[0].string), nullptr, CISAlineno));
    }
#line 3326 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 54: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS  */
#line 842 "CISA.y"
                                       {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-1].string), nullptr, CISAlineno));
    }
#line 3334 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 55: /* DirectiveFunc: DIRECTIVE_FUNC IdentOrStringLit  */
#line 848 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_function_directive((yyvsp[0].string), CISAlineno));
    }
#line 3342 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 56: /* AlignAttrOpt: %empty  */
#line 853 "CISA.y"
                     {(yyval.align) = ALIGN_BYTE;}
#line 3348 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 58: /* Align: ALIGN_EQ ALIGN_KEYWORD  */
#line 855 "CISA.y"
                           { // 2GRF, 32word, ...
        (yyval.align) = (yyvsp[0].align);
    }
#line 3356 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 59: /* Align: ALIGN_EQ IDENT  */
#line 859 "CISA.y"
                   { // e.g. byte, word, dword, qword, GRF, GRFx2
       if (!ParseAlign(pBuilder, (yyvsp[0].string), (yyval.align))) {
           PARSE_ERROR((yyvsp[0].string), ": invalid align value");
       }
    }
#line 3366 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 60: /* Align: ALIGN_EQ IntExp  */
#line 865 "CISA.y"
                    {
        // e.g. %sizeof(GRF) or %sizeof(DECL)
        (yyval.align) = AlignBytesToVisaAlignment((int)(yyvsp[0].intval));
        if ((yyval.align) == ALIGN_UNDEF) {
            PARSE_ERROR("invalid align size (must be 1, 2, 4, 8, ..., 128)");
        }
    }
#line 3378 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 61: /* Align: ALIGN_EQ error  */
#line 873 "CISA.y"
                   {
        PARSE_ERROR("syntax error in align attribute");
    }
#line 3386 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 62: /* AliasAttrOpt: %empty  */
#line 880 "CISA.y"
    {
       (yyval.alias).aliasname = NULL;
       (yyval.alias).offset = 0;
    }
#line 3395 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 63: /* AliasAttrOpt: ALIAS_EQ LANGLE Var COMMA IntExpNRA RANGLE  */
#line 885 "CISA.y"
    {
       (yyval.alias).aliasname = (yyvsp[-3].string);
       (yyval.alias).offset = (int)(yyvsp[-1].intval);
    }
#line 3404 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 64: /* AliasAttrOpt: ALIAS_EQ LANGLE error  */
#line 890 "CISA.y"
    {
       PARSE_ERROR("syntax error in alias attribute");
    }
#line 3412 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 65: /* OneAttr: IDENT EQUALS IntExpNRA  */
#line 896 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), (yyvsp[0].intval), nullptr);
    }
#line 3420 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 66: /* OneAttr: IDENT EQUALS STRING_LIT  */
#line 900 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), 0, (yyvsp[0].string));
    }
#line 3428 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 67: /* OneAttr: IDENT  */
#line 904 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[0].string), 0, nullptr);
    }
#line 3436 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 68: /* AttrOpt: AttrOpt COMMA OneAttr  */
#line 910 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3444 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 69: /* AttrOpt: OneAttr  */
#line 915 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3452 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 70: /* GenAttrOpt: %empty  */
#line 921 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 3460 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 71: /* GenAttrOpt: ATTR_EQ LBRACE AttrOpt RBRACE  */
#line 925 "CISA.y"
    {
        (yyval.intval) = 1;
    }
#line 3468 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 124: /* Label: LABEL  */
#line 987 "CISA.y"
             {pBuilder->CISA_create_label((yyvsp[0].string), CISAlineno);}
#line 3474 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 125: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 992 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3483 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 126: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar PredVar  */
#line 998 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].vISADecl), (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), CISAlineno);
    }
#line 3491 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 127: /* LogicInstruction: Predicate TERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1003 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3500 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 128: /* LogicInstruction: Predicate QUATERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1009 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-8].pred_reg), (yyvsp[-7].opcode), (yyvsp[-6].sat), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3509 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 129: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1016 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, NULL, CISAlineno);
    }
#line 3518 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 130: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar  */
#line 1022 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), NULL, CISAlineno);
    }
#line 3527 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 131: /* MathInstruction_2OPND: Predicate MATH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1029 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3536 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 132: /* MathInstruction_3OPND: Predicate MATH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1036 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3545 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 133: /* ArithInstruction_2OPND: Predicate ARITH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1043 "CISA.y"
    {
        pBuilder->CISA_create_arith_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3554 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 134: /* ArithInstruction_3OPND: Predicate ARITH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1050 "CISA.y"
    {
        MUST_HOLD(!(((yyvsp[-5].opcode) == ISA_LINE) && ((yyvsp[-1].genOperand).type == OPERAND_IMMEDIATE || (yyvsp[-1].genOperand).type == OPERAND_INDIRECT)),
            "wrong type of src0 operand");
        pBuilder->CISA_create_arith_instruction(
            (yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3566 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 135: /* ArithInstruction_3OPND: Predicate ARITH5_OP2 ExecSize VecDstOperand_G_I PredVar VecSrcOperand_G_I_IMM  */
#line 1060 "CISA.y"
    {
        pBuilder->CISA_create_arith_instruction2_predDst((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].vISADecl), (yyvsp[0].genOperand).cisa_gen_opnd, nullptr, CISAlineno);
    }
#line 3575 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 136: /* ArithInstruction_4OPND: Predicate ARITH4_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1069 "CISA.y"
     {
         pBuilder->CISA_create_arith_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3584 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 137: /* ArithInstruction_4OPND: Predicate ARITH4_OP2 ExecSize VecDstOperand_G_I VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1076 "CISA.y"
     {
        pBuilder->CISA_create_arith_instruction2((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3593 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 138: /* ArithInstruction_4OPND: Predicate ARITH5_OP2 ExecSize VecDstOperand_G_I PredVar VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1083 "CISA.y"
     {
        pBuilder->CISA_create_arith_instruction2_predDst((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].vISADecl), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3602 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 139: /* DpasInstruction: DPAS_OP ExecSize RawOperand RawOperand RawOperand VecSrcOpndSimple  */
#line 1092 "CISA.y"
    {
        pBuilder->CISA_create_dpas_instruction(
            (yyvsp[-5].dpas_info).opcode, (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].genOperand).cisa_gen_opnd,
            (yyvsp[-5].dpas_info).src2Precision, (yyvsp[-5].dpas_info).src1Precision, (yyvsp[-5].dpas_info).depth, (yyvsp[-5].dpas_info).count, CISAlineno);
    }
#line 3613 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 140: /* BfnInstruction: Predicate BFN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1102 "CISA.y"
    {
        pBuilder->CISA_create_bfn_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].bfn_info).func_ctrl , (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3622 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 141: /* QwScatterInstruction: Predicate QW_SCATTER_OP DOT DEC_LIT ExecSize Var RawOperand RawOperand  */
#line 1108 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_qword_scatter_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (uint32_t)(yyvsp[-4].intval), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3631 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 142: /* FCvtInstruction: FCVT_OP SatModOpt ExecSize VecDstOperand_G VecSrcOperand_G_IMM  */
#line 1115 "CISA.y"
    {
        pBuilder->CISA_create_fcvt_instruction((yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3639 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 143: /* AntiTrigInstruction: Predicate ANTI_TRIG_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1121 "CISA.y"
    {
        pBuilder->CISA_create_invtri_inst((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3648 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 144: /* AddrAddInstruction: ADDR_ADD_OP ExecSize VecDstOperand_A VecSrcOperand_G_A_AO VecSrcOperand_G_IMM_AO  */
#line 1130 "CISA.y"
    {
        // a grammatically problematic instruction
        //   addr_add (M1_NM, 1) A0(0)<1> &V127 - 0x10...
        //                                        ^^^^ next operand or V127 offset
        pBuilder->CISA_create_address_instruction((yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3660 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 145: /* SetpInstruction: SETP_OP ExecSize PredVar VecSrcOperand_G_I_IMM  */
#line 1140 "CISA.y"
    {
        pBuilder->CISA_create_setp_instruction(
            (yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].vISADecl), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3669 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 146: /* SelInstruction: Predicate SEL_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1147 "CISA.y"
    {
        pBuilder->CISA_create_sel_instruction((yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3678 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 147: /* MinInstruction: Predicate MIN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1154 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(0, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3687 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 148: /* MaxInstruction: Predicate MAX_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1162 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(
            1, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3697 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 149: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM_A_AO  */
#line 1171 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno));
    }
#line 3707 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 150: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_A VecSrcOperand_G_I_IMM_A_AO  */
#line 1178 "CISA.y"
    {
        pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3717 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 151: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I PredVar  */
#line 1185 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction((yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].vISADecl), CISAlineno));
    }
#line 3725 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 152: /* BreakpointInstruction: BREAKPOINT_OP  */
#line 1191 "CISA.y"
    {
      pBuilder->CISA_create_breakpoint_instruction(CISAlineno);
    }
#line 3733 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 153: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand SrcStateOperand  */
#line 1197 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3742 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 154: /* MovsInstruction: MOVS_OP ExecSize VecDstOperand_G SrcStateOperand  */
#line 1203 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3751 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 155: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand VecSrcOperand_G_I_IMM  */
#line 1209 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3760 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 156: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize PredVar VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1227 "CISA.y"
    {
        pBuilder->CISA_create_cmp_instruction((yyvsp[-4].cond_mod), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].vISADecl), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3769 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 157: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1234 "CISA.y"
    {
        // NOTE: predication not permitted.  Apparently the vISA API doesn't allow for predicated compares
        pBuilder->CISA_create_cmp_instruction(
            (yyvsp[-4].cond_mod), ISA_CMP, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3780 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 158: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var MediaInstructionPlaneID VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1244 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-7].opcode), (yyvsp[-6].media_mode), (yyvsp[-5].offset).row, (yyvsp[-5].offset).elem, (int)(yyvsp[-3].intval), (yyvsp[-4].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3790 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 159: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1252 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-6].opcode), (yyvsp[-5].media_mode), (yyvsp[-4].offset).row, (yyvsp[-4].offset).elem, (int)0, (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3800 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 160: /* MediaInstructionPlaneID: DEC_LIT  */
#line 1258 "CISA.y"
                                 {
        MUST_HOLD((yyvsp[0].intval) <= 0xF, "PlaneID must less than 0xF");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 3809 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 161: /* ScatterInstruction: SCATTER_OP ElemNum ExecSize OwordModifier Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1266 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_instruction(
            (yyvsp[-7].opcode), (int)(yyvsp[-6].intval), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].oword_mod), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3819 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 162: /* ScatterTypedInstruction: Predicate SCATTER_TYPED_OP SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1275 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_typed_instruction(
            (yyvsp[-8].opcode), (yyvsp[-9].pred_reg), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-5].string),
            (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3829 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 163: /* Scatter4ScaledInstruction: Predicate SCATTER4_SCALED_OP SAMPLER_CHANNEL ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1284 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_scaled_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-5].s_channel)), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3839 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 164: /* ScatterScaledInstruction: Predicate SCATTER_SCALED_OP DOT DEC_LIT ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1293 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_scaled_instruction(
            (yyvsp[-7].opcode), (yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (uint32_t) (yyvsp[-5].intval), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3849 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 165: /* SynchronizationInstruction: BARRIER_OP  */
#line 1300 "CISA.y"
               {
        pBuilder->CISA_create_sync_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 3857 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 166: /* SynchronizationInstruction: SBARRIER_SIGNAL  */
#line 1303 "CISA.y"
                      {
        pBuilder->CISA_create_sbarrier_instruction(true, CISAlineno);
    }
#line 3865 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 167: /* SynchronizationInstruction: SBARRIER_WAIT  */
#line 1306 "CISA.y"
                    {
        pBuilder->CISA_create_sbarrier_instruction(false, CISAlineno);
    }
#line 3873 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 168: /* SynchronizationInstruction: NBARRIER_SIGNAL VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1309 "CISA.y"
                                                                                                              {
        pBuilder->CISA_create_nbarrier_signal((yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3881 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 169: /* SynchronizationInstruction: NBARRIER_SIGNAL VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1312 "CISA.y"
                                                                  {
        pBuilder->CISA_create_nbarrier(false, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3889 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 170: /* SynchronizationInstruction: NBARRIER_WAIT VecSrcOperand_G_I_IMM  */
#line 1315 "CISA.y"
                                          {
        pBuilder->CISA_create_nbarrier(true, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3897 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 171: /* DwordAtomicInstruction: Predicate DWORD_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand  */
#line 1321 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_dword_atomic_instruction(
            (yyvsp[-9].pred_reg), (yyvsp[-7].atomic_op), (yyvsp[-6].flag), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3906 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 172: /* TypedAtomicInstruction: Predicate TYPED_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1328 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_typed_atomic_instruction(
            (yyvsp[-12].pred_reg), (yyvsp[-10].atomic_op), (yyvsp[-9].flag), (yyvsp[-8].emask_exec_size).emask, (yyvsp[-8].emask_exec_size).exec_size, (yyvsp[-7].string),
            (yyvsp[-6].RawVar), (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3916 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 173: /* Atomic16Opt: %empty  */
#line 1335 "CISA.y"
             {(yyval.flag) = false;}
#line 3922 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 174: /* Atomic16Opt: DOT DEC_LIT  */
#line 1336 "CISA.y"
                  { // .16
        MUST_HOLD(((yyvsp[0].intval) == 16), "only supports 16");
        (yyval.flag) = true;
    }
#line 3931 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 175: /* SampleUnormInstruction: SAMPLE_UNORM_OP SAMPLER_CHANNEL CHANNEL_OUTPUT Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1343 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sampleunorm_instruction(
            (yyvsp[-9].opcode), ChannelMask::createFromAPI((yyvsp[-8].s_channel)), (yyvsp[-7].s_channel_output), (yyvsp[-6].string), (yyvsp[-5].string),
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3941 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 176: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var Var RawOperand RawOperand RawOperand RawOperand  */
#line 1356 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
            (yyvsp[-8].opcode), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (int)(yyvsp[-6].intval), (yyvsp[-5].string), (yyvsp[-4].string),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3951 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 177: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var RawOperand RawOperand RawOperand RawOperand  */
#line 1364 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
           (yyvsp[-7].opcode), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (int)(yyvsp[-5].intval), "", (yyvsp[-4].string),
           (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3961 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 178: /* SamplerAddrOperand: Var  */
#line 1371 "CISA.y"
                     {
                      (yyval.sampler_base) = {(yyvsp[0].string), (unsigned int)0};
                     }
#line 3969 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 179: /* SamplerAddrOperand: LPAREN Var COMMA IntExpPrim RPAREN  */
#line 1376 "CISA.y"
                     {
                      (yyval.sampler_base) = {(yyvsp[-3].string), (unsigned int)(yyvsp[-1].intval)};
                     }
#line 3977 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 180: /* Sample3dInstruction: Predicate SAMPLE_3D_OP PixelNullMaskEnableOpt CPSEnableOpt NonUniformSamplerEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM SamplerAddrOperand SamplerAddrOperand RawOperand RawOperand RawOperandArray  */
#line 1387 "CISA.y"
   {
       const bool success = pBuilder->create3DSampleInstruction(
           (yyvsp[-12].pred_reg), (yyvsp[-11].sample3DOp), (yyvsp[-10].pixel_null_mask), (yyvsp[-9].cps), (yyvsp[-8].non_uniform_sampler), ChannelMask::createFromAPI((yyvsp[-7].s_channel)),
           (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].sampler_base).base, (yyvsp[-4].sampler_base).offset,
           (yyvsp[-3].sampler_base).base, (yyvsp[-3].sampler_base).offset,
           (yyvsp[-1].RawVar), (yyvsp[-2].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3991 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 181: /* CPSEnableOpt: %empty  */
#line 1397 "CISA.y"
                     {(yyval.cps) = false;}
#line 3997 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 182: /* CPSEnableOpt: CPS  */
#line 1397 "CISA.y"
                                          {(yyval.cps) = true;}
#line 4003 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 183: /* NonUniformSamplerEnableOpt: %empty  */
#line 1399 "CISA.y"
                                   {(yyval.non_uniform_sampler) = false;}
#line 4009 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 184: /* NonUniformSamplerEnableOpt: NON_UNIFORM_SAMPLER  */
#line 1399 "CISA.y"
                                                                       {(yyval.non_uniform_sampler) = true;}
#line 4015 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 185: /* Load3dInstruction: Predicate LOAD_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM SamplerAddrOperand RawOperand RawOperand RawOperandArray  */
#line 1409 "CISA.y"
   {
       const bool success = pBuilder->create3DLoadInstruction(
           (yyvsp[-9].pred_reg), (yyvsp[-8].sample3DOp), (yyvsp[-7].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-6].s_channel)),
           (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].sampler_base).base, (yyvsp[-3].sampler_base).offset,
           (yyvsp[-1].RawVar), (yyvsp[-2].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 4028 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 186: /* Gather43dInstruction: Predicate SAMPLE4_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM SamplerAddrOperand SamplerAddrOperand RawOperand RawOperand RawOperandArray  */
#line 1426 "CISA.y"
   {
       const bool success = pBuilder->createSample4Instruction(
          (yyvsp[-10].pred_reg), (yyvsp[-9].sample3DOp), (yyvsp[-8].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size,
          (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].sampler_base).base, (yyvsp[-4].sampler_base).offset, (yyvsp[-3].sampler_base).base, (yyvsp[-3].sampler_base).offset,
           (yyvsp[-1].RawVar), (yyvsp[-2].RawVar),
          (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 4042 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 187: /* PixelNullMaskEnableOpt: %empty  */
#line 1437 "CISA.y"
                               {(yyval.pixel_null_mask) = false;}
#line 4048 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 188: /* PixelNullMaskEnableOpt: PIXEL_NULL_MASK  */
#line 1437 "CISA.y"
                                                               {(yyval.pixel_null_mask) = true;}
#line 4054 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 189: /* ResInfo3dInstruction: RESINFO_OP_3D SAMPLER_CHANNEL ExecSize SamplerAddrOperand RawOperand RawOperand  */
#line 1441 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_RESINFO, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-4].s_channel)), (yyvsp[-2].sampler_base).base, (yyvsp[-2].sampler_base).offset, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4064 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 190: /* SampleInfo3dInstruction: SAMPLEINFO_OP_3D SAMPLER_CHANNEL ExecSize SamplerAddrOperand RawOperand  */
#line 1449 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_SAMPLEINFO, (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-3].s_channel)), (yyvsp[-1].sampler_base).base, (yyvsp[-1].sampler_base).offset, NULL, (yyvsp[0].RawVar), CISAlineno));
   }
#line 4074 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 191: /* RTWriteOperands: %empty  */
#line 1457 "CISA.y"
    {
    }
#line 4081 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 192: /* RTWriteOperands: RTWriteOperands VecSrcOperand_G_IMM  */
#line 1460 "CISA.y"
    {
        RTRWOperandsVec.push_back((yyvsp[0].genOperand).cisa_gen_opnd);
    }
#line 4089 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 193: /* RTWriteOperands: RTWriteOperands RawOperand  */
#line 1464 "CISA.y"
    {
        RTRWOperandsVec.push_back((yyvsp[0].RawVar));
    }
#line 4097 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 194: /* RTWriteInstruction: Predicate RTWRITE_OP_3D RTWriteModeOpt ExecSize Var RTWriteOperands  */
#line 1472 "CISA.y"
   {
       bool result = pBuilder->CISA_create_rtwrite_3d_instruction(
           (yyvsp[-5].pred_reg), (yyvsp[-3].string), (yyvsp[-2].emask_exec_size).emask, (unsigned int)(yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].string),
           RTRWOperandsVec, CISAlineno);
       RTRWOperandsVec.clear();
       if (!result)
           YYABORT; // already reported
   }
#line 4110 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 195: /* RTWriteModeOpt: %empty  */
#line 1482 "CISA.y"
                       {(yyval.string) = 0;}
#line 4116 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 197: /* URBWriteInstruction: Predicate URBWRITE_OP_3D ExecSize DEC_LIT DEC_LIT RawOperand RawOperand RawOperand RawOperand  */
#line 1487 "CISA.y"
    {
        pBuilder->CISA_create_urb_write_3d_instruction(
            (yyvsp[-8].pred_reg), (yyvsp[-6].emask_exec_size).emask, (unsigned int)(yyvsp[-6].emask_exec_size).exec_size, (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-4].intval),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4126 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 198: /* AVSInstruction: AVS_OP SAMPLER_CHANNEL Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM CNTRL VecSrcOperand_G_I_IMM EXECMODE VecSrcOperand_G_I_IMM RawOperand  */
#line 1495 "CISA.y"
    {
        pBuilder->CISA_create_avs_instruction(
            ChannelMask::createFromAPI((yyvsp[-14].s_channel)), (yyvsp[-13].string), (yyvsp[-12].string),
            (yyvsp[-11].genOperand).cisa_gen_opnd, (yyvsp[-10].genOperand).cisa_gen_opnd, (yyvsp[-9].genOperand).cisa_gen_opnd, (yyvsp[-8].genOperand).cisa_gen_opnd,
            (yyvsp[-7].genOperand).cisa_gen_opnd, (yyvsp[-6].genOperand).cisa_gen_opnd, (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].cntrl), (yyvsp[-3].genOperand).cisa_gen_opnd,
            (yyvsp[-2].execMode), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4138 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 199: /* VMEInstruction: VME_IME_OP VMEOpndIME Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1507 "CISA.y"
   {
       //     1 - OP
       //     2 - StreamMode, SearchCtrl
       //     3 - Surface
       //     4 - UNIInput
       //     5 - IMEInput
       //     6 - ref0
       //     7 - ref1
       //     8 - CostCenter
       //     9 - Output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_ime_instruction(
            (yyvsp[-8].opcode), (yyvsp[-7].vmeOpndIvb).streamMode, (yyvsp[-7].vmeOpndIvb).searchCtrl, (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-6].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4156 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 200: /* VMEInstruction: VME_SIC_OP Var RawOperand RawOperand RawOperand  */
#line 1523 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_sic_instruction((yyvsp[-4].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4164 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 201: /* VMEInstruction: VME_FBR_OP VMEOpndFBR Var RawOperand RawOperand RawOperand  */
#line 1529 "CISA.y"
   {
        //    1 - OP
        //    2 - FBRMdMode, FBRSubMbShape, FBRSubPredMode
        //    3 - surface
        //    4 - UNIInput
        //    5 - FBRInput
        //    6 - output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_fbr_instruction((yyvsp[-5].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string),
            (yyvsp[-4].vmeOpndFbr).cisa_fbrMbMode_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubMbShape_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubPredMode_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4179 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 202: /* OwordInstruction: OWORD_OP OwordModifier ExecSize Var VecSrcOperand_G_I_IMM RawOperand  */
#line 1542 "CISA.y"
    {
        ABORT_ON_FAIL(
            pBuilder->CISA_create_oword_instruction((yyvsp[-5].opcode), (yyvsp[-4].oword_mod), (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4188 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 203: /* SvmInstruction: SVM_OP SVM_ALIGNED ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1550 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-4].opcode),
(yyvsp[-2].emask_exec_size).exec_size, false, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4197 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 204: /* SvmInstruction: SVM_OP SVM_UNALIGNED ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1557 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-4].opcode),
(yyvsp[-2].emask_exec_size).exec_size, true, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4206 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 205: /* SvmInstruction: SVM_OP ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1565 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-3].opcode),
(yyvsp[-2].emask_exec_size).exec_size, true, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4215 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 206: /* SvmInstruction: Predicate SVM_SCATTER_OP DOT DEC_LIT DOT DEC_LIT ExecSize RawOperand RawOperand  */
#line 1571 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter_instruction((yyvsp[-8].pred_reg), (SVMSubOpcode)(yyvsp[-7].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-3].intval), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4224 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 207: /* SvmInstruction: Predicate SVM_ATOMIC_OP ATOMIC_SUB_OP AtomicBitwidthOpt ExecSize RawOperand RawOperand RawOperand RawOperand  */
#line 1577 "CISA.y"
    {
        pBuilder->CISA_create_svm_atomic_instruction((yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-6].atomic_op), (unsigned short)(yyvsp[-5].intval),
            (yyvsp[-3].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), (yyvsp[-2].RawVar), CISAlineno);
    }
#line 4233 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 208: /* SvmInstruction: Predicate SVM_GATHER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1583 "CISA.y"
    {
        pBuilder->CISA_create_svm_gather4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4242 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 209: /* SvmInstruction: Predicate SVM_SCATTER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1589 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4251 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 210: /* AtomicBitwidthOpt: %empty  */
#line 1595 "CISA.y"
             {(yyval.intval) = 32;}
#line 4257 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 211: /* AtomicBitwidthOpt: DOT DEC_LIT  */
#line 1596 "CISA.y"
                  {
        MUST_HOLD((yyvsp[0].intval) == 16 || (yyvsp[0].intval) == 32 || (yyvsp[0].intval) == 64, "only supports 16 or 64");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 4266 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 224: /* LscUntypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand  */
#line 1651 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[0].lsc_addr_operand).surfaceIndex, // surface index
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0
            nullptr,     // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4291 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 225: /* LscUntypedStridedLoad: Predicate LSC_LOAD_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedStridedAddrOperand  */
#line 1683 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[0].lsc_addr_operand).surfaceIndex, // surface index
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[0].lsc_addr_operand).regs[1],  // src0 stride
            nullptr,     // src1
            CISAlineno);
    }
#line 4316 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 226: /* LscUntypedBlock2dLoad: Predicate LSC_LOAD_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand2D LscUntypedBlock2dAddrOperand  */
#line 1713 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_data_operand2d).shape2D,  // data shape
            (yyvsp[-1].lsc_data_operand2d).reg,      // dst
            (yyvsp[0].lsc_block2d_addr_operand).regs,     // src0 surface info / addrs
            nullptr,     // src1
            (yyvsp[0].lsc_block2d_addr_operand).immOffsets[0],
            (yyvsp[0].lsc_block2d_addr_operand).immOffsets[1],
            CISAlineno);
    }
#line 4339 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 227: /* LscUntypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedAddrOperand LscDataOperand  */
#line 1741 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_addr_operand).surfaceIndex, // surface index
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0
            (yyvsp[0].lsc_data_operand).reg,      // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4364 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 228: /* LscUntypedStridedStore: Predicate LSC_STORE_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedStridedAddrOperand LscDataOperand  */
#line 1767 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_addr_operand).surfaceIndex, // surface index
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[-1].lsc_addr_operand).regs[1],  // src0 stride
            (yyvsp[0].lsc_data_operand).reg,      // src1
            CISAlineno);
    }
#line 4389 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 229: /* LscUntypedBlock2dStore: Predicate LSC_STORE_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedBlock2dAddrOperand LscDataOperand2D  */
#line 1795 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_data_operand2d).shape2D,  // data2d
            nullptr,     // dst
            (yyvsp[-1].lsc_block2d_addr_operand).regs,     // src0 addrs
            (yyvsp[0].lsc_data_operand2d).reg,      // src1
            (yyvsp[-1].lsc_block2d_addr_operand).immOffsets[0],
            (yyvsp[-1].lsc_block2d_addr_operand).immOffsets[1],
            CISAlineno);
    }
#line 4412 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 230: /* LscUntypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand LscPayloadReg LscPayloadReg  */
#line 1824 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),                // op
            (yyvsp[-6].lsc_sfid),                // sfid
            (yyvsp[-5].lsc_caching_opts),                // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_addr_operand).addr,         // address info
            (yyvsp[-3].lsc_data_operand).shape,        // data type
            (yyvsp[-2].lsc_addr_operand).surface,      // surface array base
            (yyvsp[-2].lsc_addr_operand).surfaceIndex, // surface index
            (yyvsp[-3].lsc_data_operand).reg,          // dst data
            (yyvsp[-2].lsc_addr_operand).regs[0],      // src0 addr
            (yyvsp[-1].RawVar),              // src1 data
            (yyvsp[0].RawVar),              // src2 data (for icas/fcas)
            CISAlineno);
    }
#line 4437 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 231: /* LscTypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperandWithOffsets  */
#line 1858 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_LOAD_QUAD) {
            PARSE_ERROR("unsupported load operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_typed_operand).addr.type,      // address type
            (yyvsp[0].lsc_typed_operand).addr.size,      // address size
            (yyvsp[-1].lsc_data_operand).shape,          // data
            (yyvsp[0].lsc_typed_operand).surface,        // surface
            (yyvsp[0].lsc_typed_operand).surfaceIndex,   // surface index
            (yyvsp[-1].lsc_data_operand).reg,            // dst
            (yyvsp[0].lsc_typed_operand).regs[0],        // src0_u
            (yyvsp[0].lsc_typed_operand).uvrOffsets[0],  // u offset
            (yyvsp[0].lsc_typed_operand).regs[1],        // src0_v
            (yyvsp[0].lsc_typed_operand).uvrOffsets[1],  // v offset
            (yyvsp[0].lsc_typed_operand).regs[2],        // src0_r
            (yyvsp[0].lsc_typed_operand).uvrOffsets[2],  // r offset
            (yyvsp[0].lsc_typed_operand).regs[3],        // src0_lod
            nullptr,           // src1 data
            nullptr,           // src2 data
            CISAlineno);
    }
#line 4472 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 232: /* LscTypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscTypedAddrOperandWithOffsets LscDataOperand  */
#line 1902 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_STORE_QUAD) {
            PARSE_ERROR("unsupported store operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_typed_operand).addr.type,     // address model
            (yyvsp[-1].lsc_typed_operand).addr.size,     // address size
            (yyvsp[0].lsc_data_operand).shape,         // data size
            (yyvsp[-1].lsc_typed_operand).surface,       // surface
            (yyvsp[-1].lsc_typed_operand).surfaceIndex,  // surface index
            nullptr,          // dst
            (yyvsp[-1].lsc_typed_operand).regs[0],       // src0_u
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[0], // u offset
            (yyvsp[-1].lsc_typed_operand).regs[1],       // src0_v
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[1], // v offset
            (yyvsp[-1].lsc_typed_operand).regs[2],       // src0-r
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[2], // r offset
            (yyvsp[-1].lsc_typed_operand).regs[3],       // src0_lod
            (yyvsp[0].lsc_data_operand).reg,           // stored data
            nullptr,          // src2
            CISAlineno);
    }
#line 4507 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 233: /* LscTypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperandWithOffsets LscPayloadReg LscPayloadReg  */
#line 1947 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),  // subop
            (yyvsp[-6].lsc_sfid),  // sfid
            (yyvsp[-5].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_typed_operand).addr.type, // address model
            (yyvsp[-2].lsc_typed_operand).addr.size,  // address size
            (yyvsp[-3].lsc_data_operand).shape,    // data type
            (yyvsp[-2].lsc_typed_operand).surface,  // surface
            (yyvsp[-2].lsc_typed_operand).surfaceIndex, // surface index
            (yyvsp[-3].lsc_data_operand).reg,      // dst data
            (yyvsp[-2].lsc_typed_operand).regs[0],  // src0 addrs u
            (yyvsp[-2].lsc_typed_operand).uvrOffsets[0], // u offset
            (yyvsp[-2].lsc_typed_operand).regs[1],  // src0 addrs v
            (yyvsp[-2].lsc_typed_operand).uvrOffsets[1], // v offset
            (yyvsp[-2].lsc_typed_operand).regs[2],  // src0 addrs r
            (yyvsp[-2].lsc_typed_operand).uvrOffsets[2], // r offset
            (yyvsp[-2].lsc_typed_operand).regs[3],  // src0 addrs lod
            (yyvsp[-1].RawVar),          // src1 data
            (yyvsp[0].RawVar),          // src2 data
            CISAlineno);
    }
#line 4539 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 234: /* LscTypedReadStateInfo: Predicate LSC_READ_STATE_INFO_MNEMONIC LSC_SFID_TYPED_TOKEN LscPayloadReg LscAddrModelStateful LBRACK LscPayloadNonNullReg RBRACK  */
#line 1983 "CISA.y"
   {
        LSC_CACHE_OPTS caching {LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};
        LSC_DATA_SHAPE dataShape {LSC_DATA_SIZE_32b,LSC_DATA_ORDER_TRANSPOSE};
        dataShape.elems = LSC_DATA_ELEMS_16;
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-7].pred_reg),              // predicate
            (yyvsp[-6].lsc_subOpcode),              // subop
            (yyvsp[-5].lsc_sfid),              // sfid
            caching,         // no caching settings
            EXEC_SIZE_1,
            vISA_EMASK_M1_NM,
            (yyvsp[-3].lsc_addr_model).type,           // address type
            LSC_ADDR_SIZE_32b, // address size
            dataShape,         // data type
            (yyvsp[-3].lsc_addr_model).surface,        // surface
            (yyvsp[-3].lsc_addr_model).surfaceIndex,   // SS_IDX
            (yyvsp[-4].RawVar),                // dst data
            (yyvsp[-1].RawVar),                // src0 coords (u, v, r, lod) SIMD1 are packed in
            0,                 // no uvr-offsets
            nullptr,           // no other coords
            0,                 // no uvr-offsets
            nullptr,           // no other coords
            0,                 // no uvr-offsets
            nullptr,           // no other coords
            nullptr,           // no src1 data
            nullptr,           // no src2 data
            CISAlineno);
   }
#line 4572 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 235: /* LscFence: LSC_FENCE_MNEMONIC LscSfid LSC_FENCE_OP_TYPE LSC_FENCE_SCOPE  */
#line 2020 "CISA.y"
    {
        pBuilder->CISA_create_lsc_fence((yyvsp[-2].lsc_sfid), (yyvsp[-1].lsc_fence_op), (yyvsp[0].lsc_scope), CISAlineno);
    }
#line 4580 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 238: /* LscCacheOpts: %empty  */
#line 2027 "CISA.y"
                                    {(yyval.lsc_caching_opts) = pBuilder->CISA_create_caching_opts(CISAlineno);}
#line 4586 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 239: /* LscCacheOpts: LSC_CACHING_OPT LSC_CACHING_OPT  */
#line 2028 "CISA.y"
                                    {(yyval.lsc_caching_opts) = pBuilder->CISA_create_caching_opts((yyvsp[-1].lsc_caching_opt),(yyvsp[0].lsc_caching_opt), CISAlineno);}
#line 4592 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 240: /* LscUntypedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt RBRACK LSC_ADDR_SIZE_TK  */
#line 2035 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-6].lsc_addr_model).surface, (yyvsp[-6].lsc_addr_model).surfaceIndex, {(yyvsp[-3].RawVar)}, {(yyvsp[-6].lsc_addr_model).type, (int)(yyvsp[-4].intval), (int)(yyvsp[-2].intval), (yyvsp[0].lsc_addr_size)}};
    }
#line 4600 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 241: /* LscUntypedStridedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt COMMA LscVectorOpRegOrImm32 RBRACK LSC_ADDR_SIZE_TK  */
#line 2044 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-8].lsc_addr_model).surface, (yyvsp[-8].lsc_addr_model).surfaceIndex, {(yyvsp[-5].RawVar), (yyvsp[-2].lsc_addr_surface_ident)}, {(yyvsp[-8].lsc_addr_model).type, (int)(yyvsp[-6].intval), (int)(yyvsp[-4].intval), (yyvsp[0].lsc_addr_size)}};
    }
#line 4608 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 242: /* LscUntypedStridedAddrOperand: LscUntypedAddrOperand  */
#line 2047 "CISA.y"
                            {
        (yyval.lsc_addr_operand) = (yyvsp[0].lsc_addr_operand);
        (yyval.lsc_addr_operand).regs[1] = nullptr;
    }
#line 4617 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 243: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpReg LscAddrImmOffsetOpt COMMA LscVectorOpReg LscAddrImmOffsetOpt RBRACK  */
#line 2071 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-13].lsc_addr_surface_ident),(yyvsp[-11].lsc_addr_surface_ident),(yyvsp[-9].lsc_addr_surface_ident),(yyvsp[-7].lsc_addr_surface_ident),(yyvsp[-5].lsc_addr_surface_ident),(yyvsp[-2].lsc_addr_surface_ident)},{(int)(yyvsp[-4].intval), (int)(yyvsp[-1].intval)},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4625 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 244: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpImm32 COMMA LscVectorOpImm32 RBRACK  */
#line 2091 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-11].lsc_addr_surface_ident),(yyvsp[-9].lsc_addr_surface_ident),(yyvsp[-7].lsc_addr_surface_ident),(yyvsp[-5].lsc_addr_surface_ident),(yyvsp[-3].lsc_addr_surface_ident),(yyvsp[-1].lsc_addr_surface_ident)},{0, 0},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4633 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 245: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg PLUS LPAREN IntExpUnr COMMA IntExpUnr RPAREN RBRACK  */
#line 2099 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-7].lsc_addr_surface_ident),nullptr,nullptr,nullptr,nullptr,nullptr},{(int)(yyvsp[-4].intval),(int)(yyvsp[-2].intval)},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4641 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 246: /* LscTypedAddrWithOffsetOperand: LscPayloadNonNullReg  */
#line 2104 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand) = {(yyvsp[0].RawVar), 0};
    }
#line 4649 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 247: /* LscTypedAddrWithOffsetOperand: LscPayloadNonNullReg PLUS IntExpMul  */
#line 2107 "CISA.y"
                                          {
        (yyval.lsc_typed_addr_operand) = {(yyvsp[-2].RawVar), (int)(yyvsp[0].intval)};
    }
#line 4657 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 248: /* LscTypedAddrWithOffsetOperand: LscPayloadNonNullReg MINUS IntExpMul  */
#line 2111 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand) = {(yyvsp[-2].RawVar), (int)-(yyvsp[0].intval)};
    }
#line 4665 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 249: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand  */
#line 2115 "CISA.y"
                                    {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[0].lsc_typed_addr_operand).reg}, {(yyvsp[0].lsc_typed_addr_operand).offset, 0, 0}};
      }
#line 4673 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 250: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand  */
#line 2120 "CISA.y"
      {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[-2].lsc_typed_addr_operand).reg,(yyvsp[0].lsc_typed_addr_operand).reg}, {(yyvsp[-2].lsc_typed_addr_operand).offset, (yyvsp[0].lsc_typed_addr_operand).offset, 0}};
      }
#line 4681 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 251: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand  */
#line 2126 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[-4].lsc_typed_addr_operand).reg,(yyvsp[-2].lsc_typed_addr_operand).reg,(yyvsp[0].lsc_typed_addr_operand).reg}, {(yyvsp[-4].lsc_typed_addr_operand).offset, (yyvsp[-2].lsc_typed_addr_operand).offset, (yyvsp[0].lsc_typed_addr_operand).offset}};
    }
#line 4689 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 252: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand COMMA LscPayloadNonNullReg  */
#line 2133 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[-6].lsc_typed_addr_operand).reg,(yyvsp[-4].lsc_typed_addr_operand).reg,(yyvsp[-2].lsc_typed_addr_operand).reg,(yyvsp[0].RawVar)}, {(yyvsp[-6].lsc_typed_addr_operand).offset, (yyvsp[-4].lsc_typed_addr_operand).offset, (yyvsp[-2].lsc_typed_addr_operand).offset}};
    }
#line 4697 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 253: /* LscTypedAddrOperandWithOffsets: LscAddrModelStateful LBRACK LscTypedAddrWithOffsetOperandList RBRACK LSC_ADDR_SIZE_TK  */
#line 2139 "CISA.y"
    {
        (yyval.lsc_typed_operand) = {(yyvsp[-4].lsc_addr_model).surface, (yyvsp[-4].lsc_addr_model).surfaceIndex,
               {(yyvsp[-2].lsc_typed_addr_operand_list).regs[0], (yyvsp[-2].lsc_typed_addr_operand_list).regs[1], (yyvsp[-2].lsc_typed_addr_operand_list).regs[2],(yyvsp[-2].lsc_typed_addr_operand_list).regs[3]},
               {(yyvsp[-2].lsc_typed_addr_operand_list).uvrOffsets[0], (yyvsp[-2].lsc_typed_addr_operand_list).uvrOffsets[1], (yyvsp[-2].lsc_typed_addr_operand_list).uvrOffsets[2]},
               {(yyvsp[-4].lsc_addr_model).type, 1, 0, (yyvsp[0].lsc_addr_size)}};
    }
#line 4708 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 254: /* LscAddrImmOffsetOpt: %empty  */
#line 2150 "CISA.y"
                     {(yyval.intval) =   0;}
#line 4714 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 255: /* LscAddrImmOffsetOpt: PLUS IntExpAdd  */
#line 2151 "CISA.y"
                     {(yyval.intval) =  (yyvsp[0].intval);}
#line 4720 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 256: /* LscAddrImmOffsetOpt: MINUS IntExpMul  */
#line 2152 "CISA.y"
                     {(yyval.intval) = -(yyvsp[0].intval);}
#line 4726 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 257: /* LscAddrImmScaleOpt: %empty  */
#line 2157 "CISA.y"
                     {(yyval.intval) = 1;}
#line 4732 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 258: /* LscAddrImmScaleOpt: IntExpPrim TIMES  */
#line 2158 "CISA.y"
                     {(yyval.intval) = (yyvsp[-1].intval);}
#line 4738 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 259: /* LscAddrModelOpt: %empty  */
#line 2161 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT, nullptr, 0};}
#line 4744 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 260: /* LscAddrModelOpt: LSC_AM_FLAT  */
#line 2162 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT, nullptr, 0};}
#line 4750 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 261: /* LscAddrModelOpt: LSC_AM_ARG  */
#line 2163 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_ARG, nullptr, 0};}
#line 4756 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 263: /* LscAddrModelStateful: LSC_AM_BSS LPAREN LscVectorOpRegOrImm32 RPAREN  */
#line 2168 "CISA.y"
                                                     {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BSS,(yyvsp[-1].lsc_addr_surface_ident), 0};
    }
#line 4764 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 264: /* LscAddrModelStateful: LSC_AM_BSS LPAREN LscVectorOpRegOrImm32 COMMA IntExp RPAREN  */
#line 2171 "CISA.y"
                                                                  {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BSS, (yyvsp[-3].lsc_addr_surface_ident), (int)(yyvsp[-1].intval)};
    }
#line 4772 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 265: /* LscAddrModelStateful: LSC_AM_SS LPAREN LscVectorOpRegOrImm32 RPAREN  */
#line 2174 "CISA.y"
                                                     {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_SS,(yyvsp[-1].lsc_addr_surface_ident), 0};
    }
#line 4780 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 266: /* LscAddrModelStateful: LSC_AM_SS LPAREN LscVectorOpRegOrImm32 COMMA IntExp RPAREN  */
#line 2177 "CISA.y"
                                                                  {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_SS,(yyvsp[-3].lsc_addr_surface_ident), (int)(yyvsp[-1].intval)};
    }
#line 4788 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 267: /* LscAddrModelStateful: LSC_AM_BTI LPAREN LscVectorOpRegOrImm32 RPAREN  */
#line 2180 "CISA.y"
                                                     {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BTI,(yyvsp[-1].lsc_addr_surface_ident), 0};
    }
#line 4796 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 268: /* LscAddrModelStateful: LSC_AM_BTI LPAREN LscVectorOpRegOrImm32 COMMA IntExp RPAREN  */
#line 2183 "CISA.y"
                                                                  {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BTI,(yyvsp[-3].lsc_addr_surface_ident), (int)(yyvsp[-1].intval)};
    }
#line 4804 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 271: /* LscVectorOpImm32: IntExp  */
#line 2192 "CISA.y"
           {
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_immed((yyvsp[0].intval), ISA_TYPE_UD, CISAlineno);
    }
#line 4812 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 272: /* LscVectorOpReg: Var  */
#line 2202 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[0].string),
            0, 1, 0, // region
            0, 0, // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4824 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 273: /* LscVectorOpReg: Var DOT DEC_LIT  */
#line 2210 "CISA.y"
                    {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-2].string),
            0, 1, 0, // region
            0, (unsigned char)(yyvsp[0].intval), // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4836 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 274: /* LscVectorOpReg: Var LPAREN IntExp COMMA IntExp RPAREN  */
#line 2218 "CISA.y"
                                          {
        MUST_HOLD((yyvsp[-3].intval) <= 255 || (yyvsp[-3].intval) >= 0, "row is out of bounds");
        MUST_HOLD((yyvsp[-1].intval) <= 255 || (yyvsp[-1].intval) >= 0, "col is out of bounds");
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-5].string),
            0, 1, 0,
            (unsigned char)(yyvsp[-3].intval), (unsigned char)(yyvsp[-1].intval), // row and col offset
            MODIFIER_NONE, CISAlineno);
        if ((yyval.lsc_addr_surface_ident) == nullptr) {
            PARSE_ERROR("cannot find surface variable");
        }
    }
#line 4853 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 275: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK  */
#line 2232 "CISA.y"
                                     {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4861 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 276: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK_CHMASK  */
#line 2236 "CISA.y"
                                            {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4869 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 277: /* LscDataOperand2D: LscPayloadReg LSC_DATA_SHAPE_TK_BLOCK2D  */
#line 2242 "CISA.y"
                                            {
        (yyval.lsc_data_operand2d) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape2d)};
    }
#line 4877 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 279: /* LscPayloadReg: Var  */
#line 2250 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4885 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 281: /* LscPayloadNonNullReg: VarNonNull  */
#line 2257 "CISA.y"
               {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4893 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 285: /* LscTypedBlock2dLoad: Predicate LSC_LOAD_BLOCK2D_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts LscDataOperandTyped2D LscTypedBlock2dAddrOperand  */
#line 2281 "CISA.y"
    {
        pBuilder->CISA_create_lsc_typed_block2d_inst(
            (yyvsp[-4].lsc_subOpcode),  // subop
            (yyvsp[-2].lsc_caching_opts),  // caching settings
            (yyvsp[0].lsc_block2d_addr_operand).addr.type, // address model
            (yyvsp[-1].lsc_data_operand_typed2d).shape_typed2d,  // data shape
            (yyvsp[0].lsc_block2d_addr_operand).surface,  //surface
            (yyvsp[0].lsc_block2d_addr_operand).surfaceIndex, // surface index
            (yyvsp[-1].lsc_data_operand_typed2d).reg,      // dst
            (yyvsp[0].lsc_block2d_addr_operand).regs[0],     // src0 addrs(block start offset x)
            (yyvsp[0].lsc_block2d_addr_operand).regs[1],     // src0 addrs(block start offset y)
            (yyvsp[0].lsc_block2d_addr_operand).immOffsets[0], // x immediate offset
            (yyvsp[0].lsc_block2d_addr_operand).immOffsets[1], // y immediate offset
            nullptr,     // src1
            CISAlineno);
   }
#line 4914 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 286: /* LscTypedBlock2dStore: Predicate LSC_STORE_BLOCK2D_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts LscTypedBlock2dAddrOperand LscDataOperandTyped2D  */
#line 2310 "CISA.y"
    {
        pBuilder->CISA_create_lsc_typed_block2d_inst(
            (yyvsp[-4].lsc_subOpcode),  // subop
            (yyvsp[-2].lsc_caching_opts),  // caching settings
            (yyvsp[-1].lsc_block2d_addr_operand).addr.type, // address model
            (yyvsp[0].lsc_data_operand_typed2d).shape_typed2d,  // data shape
            (yyvsp[-1].lsc_block2d_addr_operand).surface,  //surface
            (yyvsp[-1].lsc_block2d_addr_operand).surfaceIndex,
            nullptr,     // dst
            (yyvsp[-1].lsc_block2d_addr_operand).regs[0],     // src0 addrs(block start offset x)
            (yyvsp[-1].lsc_block2d_addr_operand).regs[1],     // src0 addrs(block start offset y)
            (yyvsp[-1].lsc_block2d_addr_operand).immOffsets[0], // x immediate offset
            (yyvsp[-1].lsc_block2d_addr_operand).immOffsets[1], // y immediate offset
            (yyvsp[0].lsc_data_operand_typed2d).reg,      // src1
            CISAlineno);
    }
#line 4935 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 287: /* LscTypedBlock2dAddrOperand: LscAddrModelStateful LBRACK LscVectorOpImm32 COMMA LscVectorOpImm32 RBRACK  */
#line 2336 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {(yyvsp[-5].lsc_addr_model).surface, 0, {(yyvsp[-3].lsc_addr_surface_ident),(yyvsp[-1].lsc_addr_surface_ident)},{0,0},{(yyvsp[-5].lsc_addr_model).type,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4943 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 288: /* LscTypedBlock2dAddrOperand: LscAddrModelStateful LBRACK LscVectorOpReg LscAddrImmOffsetOpt COMMA LscVectorOpReg LscAddrImmOffsetOpt RBRACK  */
#line 2346 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {(yyvsp[-7].lsc_addr_model).surface, (yyvsp[-7].lsc_addr_model).surfaceIndex, {(yyvsp[-5].lsc_addr_surface_ident), (yyvsp[-2].lsc_addr_surface_ident)}, {(int)(yyvsp[-4].intval), (int)(yyvsp[-1].intval)}, {(yyvsp[-7].lsc_addr_model).type, 1, 0, LSC_ADDR_SIZE_64b}};
    }
#line 4951 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 289: /* LscDataOperandTyped2D: LscPayloadReg LSC_DATA_SHAPE_TK_TYPED_BLOCK2D  */
#line 2352 "CISA.y"
                                                  {
        (yyval.lsc_data_operand_typed2d) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape_typed2d)};
    }
#line 4959 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 290: /* LscUntypedApndCtrAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscAddrModelStateful LscDataOperand  */
#line 2364 "CISA.y"
    {
        (yyvsp[-3].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-5].lsc_sfid), (yyvsp[-6].lsc_subOpcode), (yyvsp[-2].lsc_data_operand).shape.order, (yyvsp[-3].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_append_counter_atomic_inst(
            (yyvsp[-6].lsc_subOpcode),          // op
            (yyvsp[-7].pred_reg),          // predicate
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-3].emask_exec_size).exec_size),
            (yyvsp[-3].emask_exec_size).emask,    // execution mask
            (yyvsp[-4].lsc_caching_opts),          // caching settings
            (yyvsp[-1].lsc_addr_model).type,     // address type
            (yyvsp[-2].lsc_data_operand).shape,    // data shape
            (yyvsp[-1].lsc_addr_model).surface,  // surface
            (yyvsp[-1].lsc_addr_model).surfaceIndex,
            (yyvsp[-2].lsc_data_operand).reg,      // dst data
            (yyvsp[0].lsc_data_operand).reg,      // src1 data
            CISAlineno);
    }
#line 4981 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 291: /* SwitchLabels: %empty  */
#line 2384 "CISA.y"
    {
    }
#line 4988 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 292: /* SwitchLabels: COMMA SwitchLabels  */
#line 2387 "CISA.y"
    {
    }
#line 4995 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 293: /* SwitchLabels: IDENT SwitchLabels  */
#line 2390 "CISA.y"
    {
        // parse rule means we see last label first
        switchLabels.push_front((yyvsp[-1].string));
    }
#line 5004 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 294: /* BranchInstruction: Predicate BRANCH_OP ExecSize IdentOrStringLit  */
#line 2397 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].opcode), (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), false, CISAlineno);
    }
#line 5012 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 295: /* BranchInstruction: Predicate CALL_OP ExecSize IdentOrStringLit  */
#line 2401 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].cisa_call).opcode, (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), (yyvsp[-2].cisa_call).is_fccall, CISAlineno);
    }
#line 5020 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 296: /* BranchInstruction: Predicate RET_OP ExecSize  */
#line 2405 "CISA.y"
    {
        pBuilder->CISA_Create_Ret((yyvsp[-2].pred_reg), (yyvsp[-1].opcode), (yyvsp[0].emask_exec_size).emask, (yyvsp[0].emask_exec_size).exec_size, CISAlineno);
    }
#line 5028 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 297: /* BranchInstruction: SWITCHJMP_OP ExecSize VecSrcOperand_G_I_IMM LPAREN SwitchLabels RPAREN  */
#line 2409 "CISA.y"
    {
        pBuilder->CISA_create_switch_instruction((yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, switchLabels, CISAlineno);
        switchLabels.clear();
    }
#line 5037 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 298: /* BranchInstruction: Predicate FCALL ExecSize IDENT DEC_LIT DEC_LIT  */
#line 2415 "CISA.y"
    {
        pBuilder->CISA_create_fcall_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 5045 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 299: /* BranchInstruction: Predicate IFCALL ExecSize VecSrcOperand_G_I_IMM DEC_LIT DEC_LIT  */
#line 2420 "CISA.y"
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-5].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, false,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 5055 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 300: /* BranchInstruction: Predicate IFCALL UNIFORM ExecSize VecSrcOperand_G_I_IMM DEC_LIT DEC_LIT  */
#line 2427 "CISA.y"
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, true,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 5065 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 301: /* BranchInstruction: FADDR IdentOrStringLit VecDstOperand_G_I  */
#line 2434 "CISA.y"
    {
        pBuilder->CISA_create_faddr_instruction((yyvsp[-1].string), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 5073 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 302: /* FILE: FILE_OP STRING_LIT  */
#line 2439 "CISA.y"
    {
        pBuilder->CISA_create_FILE_instruction((yyvsp[-1].opcode), (yyvsp[0].string), CISAlineno);
    }
#line 5081 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 303: /* LOC: LOC_OP DEC_LIT  */
#line 2444 "CISA.y"
    {
        pBuilder->CISA_create_LOC_instruction((yyvsp[-1].opcode), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 5089 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 304: /* RawSendInstruction: Predicate RAW_SEND_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2450 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, false, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5098 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 305: /* RawSendInstruction: Predicate RAW_SENDC_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2457 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, true, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5107 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 306: /* LifetimeStartInst: LIFETIME_START_OP IDENT  */
#line 2464 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)0, (yyvsp[0].string), CISAlineno));
    }
#line 5115 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 307: /* LifetimeEndInst: LIFETIME_END_OP IDENT  */
#line 2470 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)1, (yyvsp[0].string), CISAlineno));
    }
#line 5123 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 308: /* RawSendsInstruction: Predicate RAW_SENDS_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2476 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5134 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 309: /* RawSendsInstruction: Predicate RAW_SENDS_EOT_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2484 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5145 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 310: /* RawSendsInstruction: Predicate RAW_SENDSC_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2492 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5156 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 311: /* RawSendsInstruction: Predicate RAW_SENDSC_EOT_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2500 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5167 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 312: /* NullaryInstruction: CACHE_FLUSH_OP  */
#line 2510 "CISA.y"
    {
        pBuilder->CISA_create_NO_OPND_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 5175 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 313: /* NullaryInstruction: WAIT_OP VecSrcOperand_G_IMM  */
#line 2515 "CISA.y"
    {
        pBuilder->CISA_create_wait_instruction((yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 5183 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 314: /* NullaryInstruction: YIELD_OP  */
#line 2520 "CISA.y"
    {
        pBuilder->CISA_create_yield_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 5191 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 315: /* NullaryInstruction: FENCE_GLOBAL_OP  */
#line 2525 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x0, CISAlineno);
    }
#line 5199 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 316: /* NullaryInstruction: FENCE_GLOBAL_OP FENCE_OPTIONS  */
#line 2530 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options), CISAlineno);
    }
#line 5207 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 317: /* NullaryInstruction: FENCE_LOCAL_OP  */
#line 2535 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x20, CISAlineno);
    }
#line 5215 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 318: /* NullaryInstruction: FENCE_LOCAL_OP FENCE_OPTIONS  */
#line 2540 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options) | 0x20, CISAlineno);
    }
#line 5223 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 319: /* NullaryInstruction: FENCE_SW_OP  */
#line 2545 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x80, CISAlineno);
    }
#line 5231 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 320: /* OwordModifier: %empty  */
#line 2549 "CISA.y"
                      {(yyval.oword_mod) = false;}
#line 5237 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 322: /* Predicate: %empty  */
#line 2556 "CISA.y"
    {
        (yyval.pred_reg) = NULL;
    }
#line 5245 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 323: /* Predicate: LPAREN PredSign PredVar PredCtrlOpt RPAREN  */
#line 2561 "CISA.y"
    {
        (yyval.pred_reg) = pBuilder->CISA_create_predicate_operand((yyvsp[-2].vISADecl), (yyvsp[-3].pred_sign), (yyvsp[-1].pred_ctrl), CISAlineno);
    }
#line 5253 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 324: /* PredSign: %empty  */
#line 2565 "CISA.y"
                 {(yyval.pred_sign) = PredState_NO_INVERSE;}
#line 5259 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 325: /* PredSign: BANG  */
#line 2565 "CISA.y"
                                                     {(yyval.pred_sign) = PredState_INVERSE;}
#line 5265 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 326: /* PredCtrlOpt: %empty  */
#line 2567 "CISA.y"
                    {(yyval.pred_ctrl) = PRED_CTRL_NON;}
#line 5271 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 328: /* SatModOpt: %empty  */
#line 2570 "CISA.y"
                  {(yyval.sat) = false;}
#line 5277 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 329: /* SatModOpt: SAT  */
#line 2570 "CISA.y"
                                      {(yyval.sat) = true;}
#line 5283 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 330: /* SrcModifier: SRCMOD_NEG  */
#line 2573 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG;}
#line 5289 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 331: /* SrcModifier: SRCMOD_ABS  */
#line 2574 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_ABS;}
#line 5295 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 332: /* SrcModifier: SRCMOD_NEGABS  */
#line 2575 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG_ABS;}
#line 5301 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 333: /* SrcModifier: SRCMOD_NOT  */
#line 2576 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NOT;}
#line 5307 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 334: /* ConditionalModifier: %empty  */
#line 2578 "CISA.y"
                            {(yyval.cond_mod) = ISA_CMP_UNDEF;}
#line 5313 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 336: /* VecDstOperand_A: DstAddrOperand  */
#line 2583 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5319 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 337: /* VecDstOperand_G: DstGeneralOperand  */
#line 2584 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5325 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 338: /* VecDstOperand_G_I: DstGeneralOperand  */
#line 2586 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5331 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 339: /* VecDstOperand_G_I: DstIndirectOperand  */
#line 2587 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 5337 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 341: /* VecSrcOperand_G_I_IMM_A_AO: SrcAddrOfOperand  */
#line 2592 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 5343 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 343: /* VecSrcOperand_G_I_IMM_A: SrcAddrOperand  */
#line 2596 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5349 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 345: /* VecSrcOperand_G_I_IMM: SrcIndirectOperand  */
#line 2600 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 5355 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 346: /* VecSrcOperand_G_I_IMM: SrcImmOperand  */
#line 2601 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5361 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 348: /* VecSrcOperand_G_IMM: SrcImmOperand  */
#line 2605 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5367 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 350: /* VecSrcOperand_G_IMM_AO: SrcImmOperand  */
#line 2609 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5373 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 351: /* VecSrcOperand_G_IMM_AO: SrcAddrOfOperand  */
#line 2610 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 5379 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 353: /* VecSrcOperand_G_A: SrcAddrOperand  */
#line 2614 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5385 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 355: /* VecSrcOperand_G_A_AO: SrcAddrOfOperand  */
#line 2618 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5391 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 356: /* VecSrcOperand_G: SrcGeneralOperand  */
#line 2620 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5397 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 357: /* VecSrcOpndSimple: Var TwoDimOffset  */
#line 2623 "CISA.y"
    {
        // simple vector operand with no modifier that has an
        // implicit src region = <1,1,0>
        (yyval.genOperand).type = OPERAND_GENERAL;
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-1].string), 1, 1, 0, (yyvsp[0].offset).row, (yyvsp[0].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5409 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 358: /* VMEOpndIME: LPAREN DEC_LIT COMMA DEC_LIT RPAREN  */
#line 2633 "CISA.y"
    {
        (yyval.vmeOpndIvb).streamMode = (unsigned char)(yyvsp[-3].intval);
        (yyval.vmeOpndIvb).searchCtrl = (unsigned char)(yyvsp[-1].intval);
    }
#line 5418 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 359: /* VMEOpndFBR: LPAREN VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM RPAREN  */
#line 2640 "CISA.y"
    {
        (yyval.vmeOpndFbr).cisa_fbrMbMode_opnd = (yyvsp[-5].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubMbShape_opnd = (yyvsp[-3].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubPredMode_opnd = (yyvsp[-1].genOperand).cisa_gen_opnd;
    }
#line 5428 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 360: /* SrcStateOperand: Var LPAREN IntExp RPAREN  */
#line 2648 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, false));
    }
#line 5438 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 361: /* DstStateOperand: Var LPAREN IntExp RPAREN  */
#line 2656 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, true));
    }
#line 5448 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 363: /* RawOperand: BUILTIN_NULL DOT DEC_LIT  */
#line 2687 "CISA.y"
    {
        MUST_HOLD((yyvsp[0].intval) == 0, "%null must have 0 as offset");
        (yyval.RawVar) = pBuilder->CISA_create_RAW_NULL_operand(CISAlineno); // can't fail
    }
#line 5457 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 364: /* RawOperandNonNull: VarNonNull RawOperandOffsetSuffix  */
#line 2694 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[-1].string), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5465 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 365: /* RawOperandOffsetSuffix: DOT DEC_LIT  */
#line 2705 "CISA.y"
                {
        MUST_HOLD((yyvsp[0].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5474 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 366: /* RawOperandOffsetSuffix: DOT LPAREN IntExp RPAREN  */
#line 2710 "CISA.y"
                             {
        MUST_HOLD((yyvsp[-1].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5483 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 367: /* RawOperandArray: %empty  */
#line 2718 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 5491 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 368: /* RawOperandArray: RawOperandArray RawOperand  */
#line 2723 "CISA.y"
    {
        rawOperandArray[(yyvsp[-1].intval)++] = (VISA_RawOpnd*)(yyvsp[0].RawVar);
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5500 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 369: /* DstAddrOperand: AddrVarAccessWithWidth  */
#line 2731 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
          pBuilder->CISA_set_address_operand(
            (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, true, CISAlineno));
    }
#line 5510 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 370: /* DstGeneralOperand: Var TwoDimOffset DstRegion  */
#line 2739 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-2].string), (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5519 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 371: /* DstGeneralOperand: Var DstRegion  */
#line 2744 "CISA.y"
                  {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-1].string), 0, 0, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5528 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 372: /* DstIndirectOperand: IndirectVarAccess DstRegion DataType  */
#line 2750 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_indirect_dst(
            (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff, (unsigned short)(yyvsp[-1].intval), (yyvsp[0].type), CISAlineno));
    }
#line 5537 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 373: /* SrcAddrOfOperand: AddrOfVar  */
#line 2771 "CISA.y"
              {
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[0].regAccess).cisa_decl, 0, CISAlineno);
    }
#line 5545 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 374: /* SrcAddrOfOperand: AddrOfVar LBRACK IntExp RBRACK  */
#line 2775 "CISA.y"
                                   {
         MUST_HOLD((short)(yyvsp[-1].intval) == (yyvsp[-1].intval), "variable address offset is too large");
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[-3].regAccess).cisa_decl, (short)(yyvsp[-1].intval), CISAlineno);
    }
#line 5554 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 375: /* AddrOfVar: AMP Var  */
#line 2781 "CISA.y"
            {
        // Both GENERAL_VAR and SURFACE_VAR are addressable
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.regAccess).cisa_decl == nullptr)
            PARSE_ERROR("unbound variable");
        (yyval.regAccess).row = 0;
        (yyval.regAccess).elem = 0;
    }
#line 5567 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 376: /* SrcAddrOperand: AddrVarAccessWithWidth  */
#line 2792 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_set_address_operand(
                (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, false, CISAlineno));
    }
#line 5577 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 377: /* SrcGeneralOperand: Var TwoDimOffset SrcRegionDirect  */
#line 2800 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5587 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 378: /* SrcGeneralOperand: SrcModifier Var TwoDimOffset SrcRegionDirect  */
#line 2807 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (yyvsp[-3].src_mod).mod, CISAlineno));
    }
#line 5597 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 379: /* SrcImmOperand: IntExpUnr DataTypeIntOrVector  */
#line 2817 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed((yyvsp[-1].intval), (yyvsp[0].type), CISAlineno);
    }
#line 5605 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 380: /* SrcImmOperand: HEX_LIT HFTYPE  */
#line 2822 "CISA.y"
                     {
        MUST_HOLD((yyvsp[-1].intval) < 0x10000, "literal too large for half float");
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed(
            (unsigned short)(yyvsp[-1].intval), ISA_TYPE_HF, CISAlineno);
    }
#line 5615 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 381: /* SrcImmOperand: FloatLit  */
#line 2830 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5623 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 382: /* SrcImmOperand: MINUS FloatLit  */
#line 2833 "CISA.y"
                     {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5631 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 383: /* SrcImmOperand: DoubleFloatLit  */
#line 2839 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5639 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 384: /* SrcImmOperand: MINUS DoubleFloatLit  */
#line 2843 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5647 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 386: /* FloatLit: DEC_LIT FTYPE  */
#line 2850 "CISA.y"
   {
        // "1:f" means 1.4e-45
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5658 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 387: /* FloatLit: HEX_LIT FTYPE  */
#line 2857 "CISA.y"
   {
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5668 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 389: /* DoubleFloatLit: DEC_LIT DFTYPE  */
#line 2865 "CISA.y"
                    {
        // "1:df" means 5e-324
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5679 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 390: /* DoubleFloatLit: HEX_LIT DFTYPE  */
#line 2871 "CISA.y"
                    {
        // to support 0x7ff0000000000000:df
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5690 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 391: /* SrcIndirectOperand: IndirectVarAccess SrcRegionIndirect DataType  */
#line 2882 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5701 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 392: /* SrcIndirectOperand: SrcModifier IndirectVarAccess SrcRegionIndirect DataType  */
#line 2890 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, (yyvsp[-3].src_mod).mod, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5712 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 393: /* DstRegion: LANGLE IntExpNRA RANGLE  */
#line 2899 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "Dst HorzStride must be 0, 1, 2, or 4");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5722 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 394: /* SrcRegionDirect: LANGLE IntExp SEMI IntExp COMMA IntExpNRA RANGLE  */
#line 2917 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-5].intval) == 0 || (yyvsp[-5].intval) == 1 || (yyvsp[-5].intval) == 2 || (yyvsp[-5].intval) == 4 || (yyvsp[-5].intval) == 8 || (yyvsp[-5].intval) == 16 || (yyvsp[-5].intval) == 32),
                 "Src Region VertStride must be 0, 1, 2, 4, 8, 16, or 32");
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Src Region Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "Src Region HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = (unsigned)(yyvsp[-5].intval);
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5738 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 396: /* SrcRegionIndirect: LANGLE IntExp COMMA DEC_LIT RANGLE  */
#line 2934 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5752 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 397: /* SrcRegionIndirect: LANGLE IntExpNRA RANGLE  */
#line 2945 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = -1;
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5764 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 398: /* IndirectVarAccess: IND_LBRACK AddrVarAccess COMMA IntExp RBRACK  */
#line 2955 "CISA.y"
                                                 {
        (yyval.regAccess) = (yyvsp[-3].regAccess);
        (yyval.regAccess).immOff = (int)(yyvsp[-1].intval);
    }
#line 5773 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 399: /* IndirectVarAccess: IND_LBRACK AddrVarAccess RBRACK  */
#line 2960 "CISA.y"
                                                 {
          (yyval.regAccess) = (yyvsp[-1].regAccess);
          (yyval.regAccess).immOff = 0;
    }
#line 5782 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 400: /* TwoDimOffset: LPAREN IntExp COMMA IntExp RPAREN  */
#line 2965 "CISA.y"
                                                {
        MUST_HOLD((yyvsp[-3].intval) >= 0, "row (register) offset must be positive");
        (yyval.offset).row = (int)(yyvsp[-3].intval);
        MUST_HOLD((yyvsp[-1].intval) >= 0 && (yyvsp[-1].intval) <= 0xFFFF, "sub-register offset out of bounds");
        (yyval.offset).elem = (int)(yyvsp[-1].intval);
    }
#line 5793 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 401: /* PredVar: Var  */
#line 2973 "CISA.y"
        {
        (yyval.vISADecl) = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.vISADecl) == nullptr)
            PARSE_ERROR((yyvsp[0].string), ": undefined predicate variable");
        if ((yyval.vISADecl)->type != PREDICATE_VAR)
            PARSE_ERROR((yyvsp[0].string), ": not a predicate variable");
    }
#line 5805 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 402: /* AddrVarAccess: Var LPAREN IntExp RPAREN  */
#line 2982 "CISA.y"
                             {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-3].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-3].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-3].string), ": not an address variable");
        }
        (yyval.regAccess).row = 1;
        (yyval.regAccess).elem = (int)(yyvsp[-1].intval);
    }
#line 5820 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 403: /* AddrVarAccessWithWidth: Var LPAREN IntExp RPAREN LANGLE IntExpNRA RANGLE  */
#line 2994 "CISA.y"
                                                     {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-6].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-6].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-6].string), ": not an address variable");
        }
        (yyval.regAccess).row = (int)(yyvsp[-1].intval);
        (yyval.regAccess).elem = (int)(yyvsp[-4].intval);
    }
#line 5835 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 404: /* SIMDMode: %empty  */
#line 3008 "CISA.y"
           {(yyval.intval) = 0;}
#line 5841 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 405: /* SIMDMode: LPAREN DEC_LIT RPAREN  */
#line 3011 "CISA.y"
    {
       MUST_HOLD(((yyvsp[-1].intval) == 8 || (yyvsp[-1].intval) == 16 || (yyvsp[-1].intval) == 32),
                 "SIMD mode can only be 8, 16, or 32");
       (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5851 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 406: /* ElemNum: DOT DEC_LIT  */
#line 3022 "CISA.y"
    {
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5859 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 407: /* ExecSize: LPAREN ExecSizeInt RPAREN  */
#line 3034 "CISA.y"
    {
        (yyval.emask_exec_size).emask = vISA_EMASK_M1;
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5868 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 408: /* ExecSize: LPAREN Var COMMA ExecSizeInt RPAREN  */
#line 3040 "CISA.y"
    {
        if (!ParseEMask((yyvsp[-3].string), (yyval.emask_exec_size).emask)) {
            PARSE_ERROR("invalid execution offset info");
        }
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5879 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 409: /* ExecSizeInt: DEC_LIT  */
#line 3048 "CISA.y"
    {
        if ((yyvsp[0].intval) != 1 && (yyvsp[0].intval) != 2 && (yyvsp[0].intval) != 4 && (yyvsp[0].intval) != 8 && (yyvsp[0].intval) != 16 && (yyvsp[0].intval) != 32) {
            PARSE_ERROR("invalid execution size");
        }
        (yyval.intval) = (unsigned short)(yyvsp[0].intval);
    }
#line 5890 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 415: /* IntExpCond: IntExpAND QUESTION IntExpAND COLON IntExpCond  */
#line 3062 "CISA.y"
                                                    {(yyval.intval) = (yyvsp[-4].intval) ? (yyvsp[-2].intval) : (yyvsp[0].intval);}
#line 5896 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 417: /* IntExpAND: IntExpAND AMP IntExpXOR  */
#line 3065 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) & (yyvsp[0].intval);}
#line 5902 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 419: /* IntExpXOR: IntExpXOR CIRC IntExpOR  */
#line 3068 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) ^ (yyvsp[0].intval);}
#line 5908 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 421: /* IntExpOR: IntExpOR PIPE IntExpCmp  */
#line 3071 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval);}
#line 5914 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 423: /* IntExpCmp: IntExpRel EQ IntExpRel  */
#line 3074 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) == (yyvsp[0].intval);}
#line 5920 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 424: /* IntExpCmp: IntExpRel NEQ IntExpRel  */
#line 3075 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) != (yyvsp[0].intval);}
#line 5926 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 426: /* IntExpRel: IntExpNRA LANGLE IntExpNRA  */
#line 3078 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) < (yyvsp[0].intval);}
#line 5932 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 427: /* IntExpRel: IntExpNRA RANGLE IntExpNRA  */
#line 3079 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) > (yyvsp[0].intval);}
#line 5938 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 428: /* IntExpRel: IntExpNRA LEQ IntExpNRA  */
#line 3080 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) <= (yyvsp[0].intval);}
#line 5944 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 429: /* IntExpRel: IntExpNRA GEQ IntExpNRA  */
#line 3081 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) >= (yyvsp[0].intval);}
#line 5950 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 432: /* IntExpShift: IntExpAdd SHL IntExpAdd  */
#line 3104 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) << (yyvsp[0].intval);}
#line 5956 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 433: /* IntExpShift: IntExpAdd SHRS IntExpAdd  */
#line 3105 "CISA.y"
                               {(yyval.intval) = (int64_t)(yyvsp[-2].intval) >> (int)(yyvsp[0].intval);}
#line 5962 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 434: /* IntExpShift: IntExpAdd SHRZ IntExpAdd  */
#line 3106 "CISA.y"
                               {(yyval.intval) = (int64_t)((uint64_t)(yyvsp[-2].intval) >> (uint64_t)(yyvsp[0].intval));}
#line 5968 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 436: /* IntExpAdd: IntExpAdd PLUS IntExpMul  */
#line 3109 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) + (yyvsp[0].intval);}
#line 5974 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 437: /* IntExpAdd: IntExpAdd MINUS IntExpMul  */
#line 3110 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) - (yyvsp[0].intval);}
#line 5980 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 439: /* IntExpMul: IntExpMul TIMES IntExpUnr  */
#line 3113 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) * (yyvsp[0].intval);}
#line 5986 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 440: /* IntExpMul: IntExpMul SLASH IntExpUnr  */
#line 3114 "CISA.y"
                                {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) / (yyvsp[0].intval);
        }
#line 5996 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 441: /* IntExpMul: IntExpMul PERCENT IntExpUnr  */
#line 3119 "CISA.y"
                                  {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) % (yyvsp[0].intval);
        }
#line 6006 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 443: /* IntExpUnr: MINUS IntExpUnr  */
#line 3126 "CISA.y"
                      {(yyval.intval) = -(yyvsp[0].intval);}
#line 6012 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 444: /* IntExpUnr: TILDE IntExpUnr  */
#line 3127 "CISA.y"
                      {(yyval.intval) = ~(yyvsp[0].intval);}
#line 6018 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 445: /* IntExpUnr: BANG IntExpUnr  */
#line 3128 "CISA.y"
                      {(yyval.intval) = !((yyvsp[0].intval));}
#line 6024 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 449: /* IntExpPrim: LPAREN IntExp RPAREN  */
#line 3136 "CISA.y"
                           {(yyval.intval) = (yyvsp[-1].intval);}
#line 6030 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 450: /* IntExpPrim: BUILTIN_SIZEOF IDENT  */
#line 3140 "CISA.y"
                           {
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[0].string), (yyval.intval)));
    }
#line 6039 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 451: /* IntExpPrim: BUILTIN_SIZEOF LPAREN IDENT RPAREN  */
#line 3144 "CISA.y"
                                         {
        // TODO: %AlignOf(...), %Max(..)
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), (yyval.intval)));
    }
#line 6049 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;

  case 452: /* IntExpPrim: BUILTIN_DISPATCH_SIMD_SIZE  */
#line 3150 "CISA.y"
                                 {
        // e.g. %DispatchSimdSize
        // N.B. %sizeof happens above
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_lookup_builtin_constant(CISAlineno, "%DispatchSimd", (yyval.intval)));
    }
#line 6060 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"
    break;


#line 6064 "/home/abuild/rpmbuild/BUILD/intel-graphics-compiler-2.5.6-build/build/IGC/visa/CISA.tab.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (pBuilder, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, pBuilder);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, pBuilder);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (pBuilder, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, pBuilder);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, pBuilder);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 3169 "CISA.y"

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                        Utility Functions                                  //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

void CISAerror(CISA_IR_Builder* pBuilder, char const *s)
{
    pBuilder->RecordParseError(CISAlineno, s);
}

static bool streq(const char *sym0, const char *sym1)
{
  return strcmp(sym0, sym1) == 0;
}

static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value)
{
    if (strcmp(sym, "byte") == 0) {
        value = ALIGN_BYTE;
    } else if (strcmp(sym, "word") == 0) {
        value = ALIGN_WORD;
    } else if (strcmp(sym, "dword") == 0) {
        value = ALIGN_DWORD;
    } else if (strcmp(sym, "qword") == 0) {
        value = ALIGN_QWORD;
    } else if (strcmp(sym, "oword") == 0) {
        value = ALIGN_OWORD;
    } else if (strcmp(sym, "GRF") == 0) {
        value = ALIGN_GRF;
    } else if (strcmp(sym, "GRFx2") == 0 || strcmp(sym, "2GRF") == 0) {
        value = ALIGN_2_GRF;
    } else if (strcmp(sym, "hword") == 0) {
        value = ALIGN_HWORD;
    } else if (strcmp(sym, "wordx32") == 0) {
        value = ALIGN_32WORD;
    } else if (strcmp(sym, "wordx64") == 0) {
        value = ALIGN_64WORD;
    } else {
        value = ALIGN_UNDEF;
        return false;
    }
    return true;
}


static VISA_Align AlignBytesToVisaAlignment(int bytes)
{
    VISA_Align val = ALIGN_UNDEF;
    switch (bytes) {
    case 1:   val = ALIGN_BYTE; break;
    case 2:   val = ALIGN_WORD; break;
    case 4:   val = ALIGN_DWORD; break;
    case 8:   val = ALIGN_QWORD; break;
    case 16:  val = ALIGN_OWORD; break;
    case 32:  val = ALIGN_HWORD; break;
    case 64:  val = ALIGN_32WORD; break;
    case 128: val = ALIGN_64WORD; break;
    default:  val = ALIGN_UNDEF; break;
    }
    return val;
}



static bool ParseEMask(
    const char* sym,
    VISA_EMask_Ctrl &emask)
{
    if (strcmp(sym, "NoMask") == 0) {
        emask = vISA_EMASK_M1_NM;
        return true;
    }
    for (int i = 0; i < vISA_NUM_EMASK +1; i++)
    {
        if (!strcmp(emask_str[i], sym))
        {
            emask = (VISA_EMask_Ctrl)i;
            return true;
        }
    }

    emask = vISA_NUM_EMASK;
    return false;
}

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size)
{
    int is_vector_op =
        op != LSC_LOAD_BLOCK2D &&
        op != LSC_STORE_BLOCK2D;
        // other ops like LSC_LOAD_SURFACE_INFO may be SIMD1
    if (op == LSC_READ_STATE_INFO) {
        exec_size = 1;
    } else if (data_order == LSC_DATA_ORDER_NONTRANSPOSE && is_vector_op) {
        if (exec_size == UNDEFINED_EXEC_SIZE) {
            if (pBuilder->getPlatform() == Xe_DG2) // for DG2 typed is 8, untyped is 16
                exec_size = sfid == LSC_TGM ? 8 : 16;
            else if (pBuilder->getPlatform() >= Xe_PVC) // on PVC typed is 16, untyped is 32
                exec_size = sfid == LSC_TGM ? 16 : 32;
            else
                exec_size = 32; // the world is finally sane
        }
    } else {
        // block and transpose get SIMD by default
        if (exec_size == UNDEFINED_EXEC_SIZE) {
           exec_size = 1; // transpose is implicitly 1 if needed
        }
    }
    return exec_size;
}
